﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class C_WarnState: SimStates
{
	
	public C_WarnState(GameObject entity, int id) : base(entity, id){}	
	public override void Enter()
	{	
		this.setTarget();		
		this.setDirection();
		this.setAnimation(SimController.State.C_WARN);
		this.simController.Stats.Idle = false;	
		if (this.simController.SetupBarrierSim.IsSimCrossBar)
		{
			
			// Update target
			this.setDirectionCurrentTargetBar();
			this.setChangeTargetToBar();
			
		}
		this.simController.InitIconSim();
	}
	
	private void setTarget()
	{
		
		this.simController.Stats.Direction = this.simController.SetupAlertSim.DirectionWarn;		
		
		float auxLimit = 0.0f;
		if (this.simController.Stats.Direction == SimController.DirectionType.LEFT)
		{
			auxLimit = GameManager.Instance.SimSetupSettings.LeftFar.x;
			
		}else if (this.simController.Stats.Direction == SimController.DirectionType.RIGHT)
		{	
			auxLimit = GameManager.Instance.SimSetupSettings.RightFar.x;
			
		}
		
		// Check if several heighs and found exit hole
		if (GameManager.Instance.SetupInitLevel.VariousHeights)
		{
			// Get exits
			List<Crack> auxListExits = new List<Crack>();
			foreach (Crack auxC in GameManager.Instance.ListCracks)
			{
				if ((auxC.TypeCrack == Crack.TCrack.EXIT_CRACK) && 
				    (auxC.NumberFloor == this.simController.Stats.Number_Floor))
				{
					auxListExits.Add(auxC);
					//exitHole = auxC;
					//break;
				}
			}
			// Check all exits
			if (auxListExits.Count > 0)
			{
				bool matchDirection = false;
				foreach (Crack auxC in auxListExits)
				{
					// Check if is in the same direction                    
					if (this.simController.Stats.Direction == SimController.DirectionType.LEFT)
					{
						if (auxC.transform.position.x <= this.simController.transform.position.x)
						{
							matchDirection = true;
						}
						
					}
					else if (this.simController.Stats.Direction == SimController.DirectionType.RIGHT)
					{
						if (auxC.transform.position.x >= this.simController.transform.position.x)
						{
							matchDirection = true;
						}
					}
					
					if (matchDirection)
					{
						this.targetPoint = new Vector3(auxC.TransformExit.position.x, auxC.TransformExit.position.y, 0.0f);
						this.directionSim = new Vector3(this.targetPoint.x - this.charController.transform.position.x,
						                                this.targetPoint.y - this.charController.transform.position.y,
						                                0.0f);
						break;
					}                     
				}
				if (!matchDirection)
				{
					float auxYPos = this.charController.transform.position.y;
					this.targetPoint = new Vector3(auxLimit, auxYPos, 0.0f);
					this.directionSim = new Vector3(this.targetPoint.x - this.charController.transform.position.x,
					                                0.0f, 0.0f);
					
				}
				
			}else
			{
				float auxYPos = this.charController.transform.position.y;		
				this.targetPoint = new Vector3(auxLimit,auxYPos,0.0f);
				this.directionSim = new Vector3(this.targetPoint.x - this.charController.transform.position.x,
				                                0.0f,0.0f);
			}
		}else
		{
			float auxYPos = this.charController.transform.position.y;		
			this.targetPoint = new Vector3(auxLimit,auxYPos,0.0f);
			this.directionSim = new Vector3(this.targetPoint.x - this.charController.transform.position.x,
			                                0.0f,0.0f);
		}
		this.simController.Stats.SpeedMovement = this.simController.Settings.C_Warn_Speed;
		
		
	}
	
	public override void UpdateState()
	{
		base.UpdateState();
		this.changeDirectionByWall();
		if (this.simController.SetupBarrierSim.IsSimCrossBar)
		{
			this.setChangeTargetToBar();
			// Check target to bar
			this.moveSim();
			
		}else
		{
			this.moveSim();
			
		}
		
	}
	
	public override void Exit(){}
	
	private void changeDirectionByWall()
	{
		if (this.simController.SetupWallSim.IsSetupWall)
		{
			// Left
			if (this.simController.transform.position.x < this.simController.SetupWallSim.PosWall.x)
			{
				if (this.simController.Stats.Direction == SimController.DirectionType.RIGHT)
				{
					this.simController.Stats.Direction = SimController.DirectionType.LEFT;
				}
				
			}else 
			{
				if (this.simController.Stats.Direction == SimController.DirectionType.LEFT)
				{
					this.simController.Stats.Direction = SimController.DirectionType.RIGHT;
				}
			}
			this.simController.SetupAlertSim.DirectionWarn = this.simController.Stats.Direction;
			this.simController.Stats.SpeedMovement = this.simController.Settings.Idle_Speed;
			this.setDirection();
			this.setTarget();
			this.simController.SetupWallSim.IsSetupWall = false;
		}
		
	}
	
}
