﻿using UnityEngine;
using System.Collections;

/// <summary>
/// This state, is a prev state before infected a civil.
/// This infection is by cat, not by another infected
/// </summary>
public class CatInfectState : SimStates
{
	private float updateTimeInfecting = 0.0f;
	private float deltaInfecting = 3.0f;
	public CatInfectState(GameObject entity, int id) : base(entity, id)
	{
	}
	
	public override void Enter()
	{
		this.setAnimation(SimController.State.INFECT_CAT);
		this.updateTimeInfecting = 0.0f;
		this.simController.Stats.SpeedMovement = this.simController.Settings.Idle_Speed;
		// Play sound when stunned
		if (this.simController.Infected_ByCat_Sound != null)
		{
			GameManager.Instance.Sound_Manager.PlaySoundEffect(this.simController.Infected_ByCat_Sound);		
		}
	}
	public override void UpdateState()
	{
		base.UpdateState();
		this.updateTimeInfecting += Time.deltaTime;
		if (this.updateTimeInfecting >= this.deltaInfecting)
		{
			this.updateTimeInfecting = 0.0f;
			this.simController.ChangeState(SimController.State.Z_HUNT);	
		}
	}
	
	public override void Exit()
	{
	}	
}

