﻿using UnityEngine;
using System.Collections;


public class FallState : SimStates
{
	//private Vector3 direction;
	private Vector2 origin;
	//private float distance;
	private bool endFall = false;
	
	public FallState(GameObject entity, int id) : base(entity, id)
	{
	}
	
	public override void Enter()
	{	
		this.simController.Stats.Idle = true;
		this.setAnimation(SimController.State.SIM_FALL);
		this.simController.Stats.SpeedMovement =  this.simController.Settings.Fall_Speed;
		if (this.simController.SetupSimFall.IsOutsideBunker)
		{
			this.directionSim = Vector3.down;
			if (this.simController.Stats.CurrentDirection == SimController.DirectionType.LEFT)
			{
				this.directionSim.x = -0.3f;
				
			}else if (this.simController.Stats.CurrentDirection == SimController.DirectionType.RIGHT)
			{
				this.directionSim.x = 0.3f;
			}
			
			
		}else
		{
			this.directionSim = Vector3.down;
		}
		
		this.origin = new Vector2(this.simController.transform.position.x,this.simController.transform.position.y);
		this.endFall = false;
		this.simController.SetDeath();
		// Remove stars
		this.simController.RemoveStarsStunned();
		this.simController.DestroyInfectedBar();
		// Disable collider
		this.simController.Settings.ShadowSim.gameObject.SetActive(false);
		
	}
	public override void UpdateState()
	{
		base.UpdateState();		
		
		if (!endFall)
		{
			Vector2 auxPos = new Vector2(this.simController.transform.position.x,this.simController.transform.position.y);
			float auxDistance = Vector2.Distance(auxPos,this.origin);
			if (auxDistance <= this.simController.SetupSimFall.DistanceFall)
			{
				this.moveSim();
				
			}else
			{
				if (this.simController.Stats.Infected)
				{
					this.setAnimation(SimController.State.Z_IDLE);
				}else
				{
					this.setAnimation(SimController.State.C_IDLE);
				}
				this.endFall = true;
				if (GameManager.Instance.SetupInitLevel.VariousHeights)
				{
					this.simController.checkFloor();
					if (this.simController.SetupSimFall.CurrentFloor != this.simController.Stats.Number_Floor)
					{					
						if (this.simController.Stats.Number_Floor == 0)
						{
							if (this.simController.SetupSimFall.IsOutsideBunker)
							{
								this.simController.ChangeState(SimController.State.Z_DEATH);
								
							}else
							{
								if (this.simController.Stats.Infected)
								{
									this.simController.ChangeState(SimController.State.Z_IDLE);
								}else
								{
									this.simController.ChangeState(SimController.State.C_IDLE);
								}
							}
						}
					}
				}
				
				if (this.simController.SetupSimFall.CurrentFloor == 0)
				{
					if (!this.simController.Stats.Infected)
					{
						// Lost sim
						GameManager.Instance.NumberLostSims += 1;
					}
				}
				
			}
		}
	}
	
	public override void Exit()
	{
		// Disable collider
		this.simController.Settings.ShadowSim.gameObject.SetActive(true);
	}	
}
