﻿using UnityEngine;
using System.Collections;

public class InactiveState : SimStates
{
	public InactiveState(GameObject entity, int id) : base(entity, id)
	{
	}
	
	public override void Enter()
	{
		this.simController.Stats.SpeedMovement =  this.simController.Settings.Idle_Speed;
		this.simController.Stats.Idle = true;
		this.setAnimation(SimController.State.INACTIVE);
		
		this.charController.transform.position = new Vector3(this.charController.transform.position.x,
		                                                     this.charController.transform.position.y,
		                                                     GameManager.Instance.SimSetupSettings.ZBackStage  );
		this.simController.SetDeath();
		
		
	}
	
	public override void UpdateState()
	{
		base.UpdateState();		
	}
	
	public override void Exit()
	{
	}
}
