﻿using UnityEngine;
using System.Collections;

public class StunnedState : SimStates
{
	public StunnedState(GameObject entity, int id) : base(entity, id)
	{
	}
	
	public override void Enter()
	{
		this.setDirection();
		this.simController.Stats.SpeedMovement =  this.simController.Settings.Idle_Speed;
		this.simController.Stats.Idle = true;
		this.setAnimation(SimController.State.STUNNED);

		// Play sound when stunned
		if (this.simController.Stunned_Sound != null)
		{
			GameManager.Instance.Sound_Manager.PlaySoundEffect(this.simController.Stunned_Sound);		
		}
	}
	
	public override void UpdateState()
	{		
		base.UpdateState();
	}
	
	public override void Exit()
	{
	}
}