﻿using UnityEngine;
using System.Collections;


/// <summary>
/// This state, is for a zombie hunting another civil
/// </summary>
public class Z_HuntState : SimStates
{
	
	public Z_HuntState(GameObject entity, int id) : base(entity, id)
	{
	}
	
	public override void Enter()
	{
		this.setAnimation(SimController.State.Z_HUNT);
		this.simController.Stats.Idle = false;				
		this.setTarget();	
		// CheckLove Cat
		this.changeDireByLoveCat();
		this.changeDirectionByWall();
		if (this.simController.SetupBarrierSim.IsSimCrossBar)
		{
			// Update target
			this.setDirectionCurrentTargetBar();
			this.setChangeTargetToBar();
			
		}		
		this.simController.Settings.HelperCircleWarn.EnableCircle(HelperCircleWarning.TypeCircle.WARN_CIRCLE);
		
	}
	
	private void setTarget()
	{
		if (this.simController.Stats.Direction == SimController.DirectionType.RIGHT)
		{
			float auxLimit = GameManager.Instance.SimSetupSettings.RightFar.x;
			this.targetPoint = new Vector3(auxLimit,this.charController.transform.position.y,0.0f);
			
		}else if (this.simController.Stats.Direction == SimController.DirectionType.LEFT)
		{
			float auxLimit = GameManager.Instance.SimSetupSettings.LeftFar.x;
			this.targetPoint = new Vector3(auxLimit,this.charController.transform.position.y,0.0f);	
			
		}
		this.directionSim = new Vector3(this.targetPoint.x - this.charController.transform.position.x,
		                                0.0f,0.0f);
		this.simController.Stats.SpeedMovement =  this.simController.Settings.Z_Hunt_Speed;	
		
	}
	
	public override void UpdateState()
	{
		base.UpdateState();	
		
		this.changeDirectionByWall();
		
		if (this.simController.SetupBarrierSim.IsSimCrossBar)
		{
			this.setChangeTargetToBar();
			// Check target to bar
			this.moveSim();
			
		}else
		{
			this.moveSim();
			
		}
	}
	
	private void changeDireByLoveCat()
	{
		if ((this.simController.SetupLoveCatSim.IsLoveCat) && 
		    (!this.simController.SetupLoveCatSim.SetupLoveCat) && (this.simController.SetupLoveCatSim.IsAffectedLoveCat) )
		{
			if (this.simController.SetupLoveCatSim.InstArrowLoveCat != null)
			{
				
				if (this.simController.transform.position.x <this.simController.SetupLoveCatSim.PositionLoveCat.x)
				{
					// Turn right
					this.simController.Stats.Direction = SimController.DirectionType.RIGHT;
					
				}else
				{
					// Turn left
					this.simController.Stats.Direction = SimController.DirectionType.LEFT;
					
				}
				this.setDirection();
				this.simController.SetupLoveCatSim.SetupLoveCat = true;
				this.setTarget();	
			}
		}			
	}
	
	private void changeDirectionByWall()
	{
		if (this.simController.SetupWallSim.IsSetupWall)
		{
			// Left
			if (this.simController.transform.position.x < this.simController.SetupWallSim.PosWall.x)
			{
				if (this.simController.Stats.Direction == SimController.DirectionType.RIGHT)
				{
					this.simController.Stats.Direction = SimController.DirectionType.LEFT;
				}
				
			}else 
			{
				if (this.simController.Stats.Direction == SimController.DirectionType.LEFT)
				{
					this.simController.Stats.Direction = SimController.DirectionType.RIGHT;
				}
			}
			this.setDirection();
			this.setTarget();	
			this.simController.SetupWallSim.IsSetupWall = false;
		}
		
	}
	
	public override void Exit()
	{
	}
}
