﻿using UnityEngine;
using System.Collections;

public class Z_HurtState : SimStates
{
	private float timeUpdateHurt = 0.0f;
	private float waitHurt = 0.3f;
	
	public Z_HurtState(GameObject entity, int id) : base(entity, id)
	{
	}
	
	public override void Enter()
	{
		if (this.simController.Stats.Lives > 0)
		{
			this.simController.Stats.SpeedMovement =  this.simController.Settings.Idle_Speed;
			this.simController.Stats.Idle = true;
			this.setAnimation(SimController.State.Z_HURT);
			this.simController.Stats.Lives -=1;
			if (this.simController.Stats.Lives <= 0)
			{
				this.simController.Stats.Lives = 0;
				
			}
			
		}
	}
	
	public override void UpdateState()
	{
		base.UpdateState();
		
		if (this.simController.Stats.Lives > 0)
		{
			this.timeUpdateHurt += Time.deltaTime;
			if (this.timeUpdateHurt >= this.waitHurt)
			{
				this.simController.ChangeState(SimController.State.Z_HUNT);
			}
			
		}else
		{
			this.timeUpdateHurt += Time.deltaTime;
			
			if (this.timeUpdateHurt >= this.waitHurt)
			{	this.simController.ChangeState(SimController.State.Z_DEATH);
			}
		}
		
	}
	
	public override void Exit()
	{
	}
}
