﻿using UnityEngine;
using System.Collections;


/// <summary>
/// Idle state for zombies
/// </summary>
public class Z_IdleState : SimStates
{
	public Z_IdleState(GameObject entity, int id) : base(entity, id){}	
	public override void Enter()
	{		
		
		this.simController.Stats.Direction = this.simController.Stats.Direction;			
		
		this.setDirection();
		this.setAnimation(SimController.State.Z_IDLE);
		this.simController.Stats.Idle = true;	
		this.simController.Stats.SpeedMovement =  this.simController.Settings.Idle_Speed;
		
		this.checkChangeDirection();
		
		this.simController.Settings.HelperCircleWarn.EnableCircle(HelperCircleWarning.TypeCircle.WARN_CIRCLE);
		
	}
	
	public override void UpdateState()
	{
		base.UpdateState();
	}
	
	private void checkChangeDirection()
	{
		if ((this.simController.SetupLoveCatSim.IsLoveCat) && 
		    (!this.simController.SetupLoveCatSim.SetupLoveCat) && (this.simController.SetupLoveCatSim.IsAffectedLoveCat))
		{
			
			if (this.simController.transform.position.x <this.simController.SetupLoveCatSim.PositionLoveCat.x)
			{
				// Turn right
				this.simController.Stats.Direction = SimController.DirectionType.RIGHT;
				
			}else
			{
				// Turn left
				this.simController.Stats.Direction = SimController.DirectionType.LEFT;
				
			}
			this.setDirection();
			this.simController.SetupLoveCatSim.SetupLoveCat = true;			
		}		
	}
	
	
	public override void Exit(){}
	
}
