﻿using UnityEngine;
using UnityEditor;
using System.Collections;
using System.Collections.Generic;


public class LevelPlayerStats  : EditorWindow
{

	List<PlayerPrefsManager.LevelStat> listLevels;
	public Vector2 scrollPosition = Vector2.zero;
	bool[] showFoldoutWorld = new bool[GameSettings.NumberWorlds];
	
	[MenuItem("Catbie/LevelPlayerStats")]
    public static void ShowWindow()
    {
        EditorWindow.GetWindow(typeof(LevelPlayerStats));		
    }


	string numberStars = "0";
	string numberWorld = "0";
	string numberLevel = "0";
	
	
	public void OnGUI()
    {
		GUILayout.Label("Change Level Stat");
		numberWorld = EditorGUILayout.TextField("Number World (0 - 2):",numberWorld);
		numberLevel = EditorGUILayout.TextField("Number Levels (0 - 20):",numberLevel);	
		numberStars = EditorGUILayout.TextField("Stars (0 - 3):",numberStars);		
				
		this.Repaint();		
		if (GUILayout.Button("Set Stat"))
        {
            setLevelStat(numberWorld,numberLevel,numberStars);
        }
		
		
		if (GUILayout.Button("Clean Levels"))
        {
            cleanLevels();
        }
		
		if (GUILayout.Button("Show Level Player Stats"))
        {
            updateLevels();
        }
		
		
		if ( listLevels != null)
		{
			
			List<PlayerPrefsManager.LevelStat> auxListWorld0 = new List<PlayerPrefsManager.LevelStat>();
			List<PlayerPrefsManager.LevelStat> auxListWorld1 = new List<PlayerPrefsManager.LevelStat>();
			List<PlayerPrefsManager.LevelStat> auxListWorld2 = new List<PlayerPrefsManager.LevelStat>();
			for (var i = 0; i < listLevels.Count; i++)
	        {				
				if (listLevels[i].WorldLevel == 0)
				{
					auxListWorld0.Add(listLevels[i]);
					
				}
				if (listLevels[i].WorldLevel == 1)
				{
					auxListWorld1.Add(listLevels[i]);
					
				}
				if (listLevels[i].WorldLevel == 2)
				{
					auxListWorld2.Add(listLevels[i]);
					
				}
	        }
			GUILayout.BeginHorizontal();
	    	GUILayout.Space(15);
	    	GUILayout.BeginVertical();
			for (int indexW = 0; indexW <GameSettings.NumberWorlds; indexW++)
	        {
				string name = "World_" + indexW;
				showFoldoutWorld[indexW] = EditorGUILayout.Foldout(showFoldoutWorld[indexW], name);
				if (showFoldoutWorld[indexW])
		        {	
					if ((auxListWorld0 != null) && (auxListWorld1 != null) && (auxListWorld2 != null))
					{
						if ((auxListWorld0.Count >= GameSettings.NumberLevelPerWorld) &&
							(auxListWorld1.Count >= GameSettings.NumberLevelPerWorld) &&
							(auxListWorld2.Count >= GameSettings.NumberLevelPerWorld))
						{
							for (int indexL = 0; indexL <GameSettings.NumberLevelPerWorld; indexL++)
				        	{							
								string nameL = "        Level ";
								if (indexL < 10)
								{
									nameL += "0";
								}
								string statL = "";
								if (indexW == 0)
								{	
									statL =  nameL + indexL + " -    [Stars: " + getNameStar(auxListWorld0[indexL].Stars)+"]";									
								}
								if (indexW == 1)
								{	
									statL =  nameL + indexL + " -    [Stars: " + getNameStar(auxListWorld1[indexL].Stars)+"]";									
								}
								if (indexW == 2)
								{	
									statL =  nameL + indexL + " -    [Stars: " + getNameStar(auxListWorld2[indexL].Stars)+"]";									
								}
							
								EditorGUILayout.LabelField(statL);
							}
							
						}
						
					}
					
		        }
			}
			GUILayout.EndVertical();
	   		GUILayout.EndHorizontal();		
			
		}
		
	}
	
	private string getNameStar(int indexStar)
	{
		string nameStar = "NONE";
		switch (indexStar)
		{	
			case 0:
				nameStar = "NONE";
			break;
			case 1:
				nameStar = "BRONZE";
			break;
			case 2:
				nameStar = "SILVER";
			break;
			case 3:
				nameStar = "GOLD";
			break;
			default:
				nameStar = "NONE";
			break;
			
		}
		return nameStar;
	}
	
	
	
	public void OnInspectorUpdate() 
	{
		this.Repaint();
	}
	
	private void cleanLevels()
    {
		PlayerPrefsManager.ResetLevels();
		updateLevels();
	}
	
	private void updateLevels()
    {
		
		listLevels = new List<PlayerPrefsManager.LevelStat>();
		listLevels = PlayerPrefsManager.GetList();
    }
	
	private void setLevelStat(string indexW, string indexL, string numberStars)
	{
		int nStars = 0;
		int nWorld = 0;
		int nLevel = 0;
		nWorld = Mathf.Clamp(int.Parse(numberWorld),0,2);
		nLevel = Mathf.Clamp(int.Parse(numberLevel),0,20);	
		nStars = Mathf.Clamp(int.Parse(numberStars),0,3);
		PlayerPrefsManager.SetLevel(nWorld,nLevel,nStars);
		
		updateLevels();
		
		numberStars = "0";
		numberWorld = "0";
		numberLevel = "0";		
	}	
}
