﻿using UnityEngine;
using UnityEditor;
using System.Collections;
using System.Collections.Generic;

public class PlayerStats : EditorWindow 
{
	
	int currentWorld = 0;
	string currentWorldTxt = "0";
	int lastWorldSelected = 0;
	string lastWorldSelectedTxt = "0";
	int currentLevel = 0;
	string currentLevelTxt = "0";
	int numberTotalCoins =0;
	string numberTotalCoinsTxt = "0";
	int numberTotalStars =0;
	string numberTotalStarsTxt = "0";
	
	[MenuItem("Catbie/PlayerStats")]
    public static void ShowWindow()
    {
        EditorWindow.GetWindow(typeof(PlayerStats));		
		
    }
	
	public void getPlayerStats()
	{
		currentWorld = PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.LOAD_ACTION,
			PlayerPrefsManager.TypePrefs.CURRENTWORLD_PREF);
		lastWorldSelected = PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.LOAD_ACTION,
			PlayerPrefsManager.TypePrefs.LASTSELECTEDWORLD_PREF);
		currentLevel = PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.LOAD_ACTION,
			PlayerPrefsManager.TypePrefs.CURRENTLEVEL_PREF);
		numberTotalCoins = PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.LOAD_ACTION,
			PlayerPrefsManager.TypePrefs.TOTALCOIN_PREF);
		numberTotalStars = PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.LOAD_ACTION,
			PlayerPrefsManager.TypePrefs.TOTALSTARS_PREF);
		
		
	}
	public void OnGUI()
    {
		//getPlayerStats();
		
        GUILayout.Label ("Player Stats", EditorStyles.boldLabel);
		
		// Current World
		EditorGUILayout.LabelField("Current World: ",currentWorld.ToString());
		currentWorldTxt = EditorGUILayout.TextField("Set World(0 - 2):",currentWorldTxt);
		if (GUILayout.Button("Set Current World"))
        {
            setCurrentWorld(currentWorldTxt);
        }
		
		if (GUILayout.Button("Clean Current Word"))
		{
			PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.CLEAN_ACTION,
				PlayerPrefsManager.TypePrefs.CURRENTWORLD_PREF,0);
			currentWorldTxt="0";
		}
		
		// Last world selected
		EditorGUILayout.LabelField("Last World Selected: ",lastWorldSelected.ToString());
		lastWorldSelectedTxt = EditorGUILayout.TextField("Set Select Last World:",lastWorldSelectedTxt);
		if (GUILayout.Button("Set Select Last World"))
        {
            setLastSelectedWorld(lastWorldSelectedTxt);
        }
		if (GUILayout.Button("Clean Last World Selected"))
		{
			PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.CLEAN_ACTION,
				PlayerPrefsManager.TypePrefs.LASTSELECTEDWORLD_PREF,0);
		}
		
		
		
		EditorGUILayout.LabelField("Current Level: ",currentLevel.ToString());
		currentLevelTxt = EditorGUILayout.TextField("Set Level(0 - 20):",currentLevelTxt);
		if (GUILayout.Button("Set Level"))
        {
            setCurrentLevel(currentLevelTxt);
        }
		if (GUILayout.Button("Clean Current Level"))
		{
			PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.CLEAN_ACTION,
				PlayerPrefsManager.TypePrefs.CURRENTLEVEL_PREF,0);
		}
		
		
		
		EditorGUILayout.LabelField("Total Coins: ",numberTotalCoins.ToString());
		numberTotalCoinsTxt = EditorGUILayout.TextField("Set Coins:",numberTotalCoinsTxt);
		if (GUILayout.Button("Set Coins"))
        {
            setTotalCoins(numberTotalCoinsTxt);
        }
		if (GUILayout.Button("Clean Total Coins"))
		{
			PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.CLEAN_ACTION,
				PlayerPrefsManager.TypePrefs.TOTALCOIN_PREF);
		}	
		
		
	
		EditorGUILayout.LabelField("Total Stars: ",numberTotalStars.ToString());
		numberTotalStarsTxt = EditorGUILayout.TextField("Set Stars:",numberTotalStarsTxt);
		if (GUILayout.Button("Set Stars"))
        {
            setTotalStars(numberTotalStarsTxt);
        }
		if (GUILayout.Button("Clean Total Stars"))
		{
			PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.CLEAN_ACTION,
				PlayerPrefsManager.TypePrefs.TOTALSTARS_PREF);
		}
		
		
    }
	
	public void OnInspectorUpdate() 
	{
		this.Repaint();
	}
	
	private void setCurrentWorld(string currentWorld)
	{
		int nCWorld = 0;
		nCWorld = Mathf.Clamp(int.Parse(currentWorld),0,2);
		PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.SAVE_ACTION,
				PlayerPrefsManager.TypePrefs.CURRENTWORLD_PREF,nCWorld);
		currentWorldTxt="0";
		getPlayerStats();
		
	}
	
	private void setLastSelectedWorld(string lastSelectedWorld)
	{
		int nLWorld = 0;
		nLWorld = Mathf.Clamp(int.Parse(lastWorldSelectedTxt),0,2);
		PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.SAVE_ACTION,
				PlayerPrefsManager.TypePrefs.LASTSELECTEDWORLD_PREF,nLWorld);
		lastWorldSelectedTxt="0";
		getPlayerStats();
		
	}
	private void setCurrentLevel(string lvl)
	{
		int levels = 0;
		levels = Mathf.Clamp(int.Parse(lvl),0,20);
		PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.SAVE_ACTION,
				PlayerPrefsManager.TypePrefs.CURRENTLEVEL_PREF,levels);
		currentLevelTxt="0";
		getPlayerStats();
		
	}
	private void setTotalCoins(string coins)
	{
		int nCoins = 0;
		nCoins = Mathf.Clamp(int.Parse(coins),0,99999);
		PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.SAVE_ACTION,
				PlayerPrefsManager.TypePrefs.TOTALCOIN_PREF,nCoins);
		numberTotalCoinsTxt="0";
		getPlayerStats();
		
	}
	private void setTotalStars(string stars)
	{
		int nStars = 0;
		nStars = Mathf.Clamp(int.Parse(stars),0,4);
		PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.SAVE_ACTION,
				PlayerPrefsManager.TypePrefs.TOTALSTARS_PREF,nStars);
		numberTotalStarsTxt="0";
		getPlayerStats();
	}
	
}
