﻿using UnityEngine;
using System.Collections;

/// <summary>
/// This component setup z of object according to Y
/// </summary>
public class ConfigZ : MonoBehaviour 
{
	
	public bool ConfigZObject = false;
	public bool UpdateZObject = false;
	
	public int Number_Floor = 0;
	
	
	public bool ClampingY = false;

	// Use this for initialization
	void Start () 
	{
		if( GetComponent<CatController>() != null && GameManager.Instance.SetupInitLevel.VariousHeights )
		{
			Number_Floor = 1;
		}
		this.Number_Floor = Mathf.Clamp(this.Number_Floor,0,10);
		if (this.ConfigZObject) 
		{
			this.configPos();
			
		}
	}
	
	// Update is called once per frame
	void Update () 
	{
		if (this.UpdateZObject)
		{
			this.configPos();
			
		}
	}
	
	private void configPos()
	{
		float posY = this.transform.position.y;
		if (this.ClampingY)
		{
			posY = ConfigZ.clamp_y(this.Number_Floor,posY);

		}

		float posZ = this.transform.position.z;
		posZ = ConfigZ.clamp_z(this.Number_Floor,posY);
		this.transform.position = new Vector3(this.transform.position.x, posY,posZ);


	
	}
	public static float clamp_y(int numberFloor, float posY)
	{
		float positionY = posY;
		float auxBL = GameManager.Instance.SimSetupSettings.ListFloorLimit[numberFloor,0];
		float auxUL = GameManager.Instance.SimSetupSettings.ListFloorLimit[numberFloor,1];
		
		positionY = Mathf.Clamp(positionY,auxBL,auxUL);

		return positionY;
	}

	public static float clamp_z(int numberFloor, float posY)
	{
		//float auxBL = GameManager.Instance.SimSetupSettings.ListFloorLimit[numberFloor,0];
		float auxUL = GameManager.Instance.SimSetupSettings.ListFloorLimit[numberFloor,1];
		float auxDistance = auxUL - posY;
		float auxOffset_z = GameManager.Instance.SimSetupSettings.OffsetZFloor * numberFloor;
		float auxZ = GameManager.Instance.SimSetupSettings.FarZSim - auxDistance;
		auxZ = Mathf.Clamp(auxZ,GameManager.Instance.SimSetupSettings.FarZ - GameManager.Instance.SimSetupSettings.WidthFloor - auxOffset_z, 
		                   GameManager.Instance.SimSetupSettings.FarZ - auxOffset_z);

		return auxZ;

	}
}
