﻿using UnityEngine;
using System.Collections;

public class Barrier : MonoBehaviour 
{

	
	public GameObject TargetLeft;
	public GameObject TargetRight;
	
	public TargetBarrier TargetBLeft;
	public TargetBarrier TargetBRight;
	
	// Use this for initialization
	void Start () 
	{
		
		if (this.TargetLeft != null)
		{
			this.TargetLeft.transform.GetComponent<MeshRenderer>().enabled = false;
			this.TargetBLeft = this.TargetLeft.transform.GetComponent<TargetBarrier>();
			
		}
		if (this.TargetRight != null)
		{
			this.TargetRight.transform.GetComponent<MeshRenderer>().enabled = false;
			this.TargetBRight = this.TargetRight.transform.GetComponent<TargetBarrier>();
			
		}
	
	}
	
	// Update is called once per frame
	void Update () 
	{
	
	}
	
	
	void OnTriggerEnter(Collider other) 
	{
		if ((other.tag == "Sim"))
		{			
			SimController auxSim = other.transform.GetComponent<SimController>();
			if (auxSim != null)
			{
				// If sim not crossing a bar 
				if (!auxSim.SetupBarrierSim.IsSimCrossBar)
				{
					auxSim.SetupBarrierSim.IsSimCrossBar = true;
					// Setup target bar according to direction and position
					// Left
					if (auxSim.transform.position.x < this.transform.position.x)
					{
						auxSim.SetupBarrierSim.FirstTargetBar = this.TargetLeft.transform.position;
						this.TargetBLeft.FistTarget = true;
						auxSim.SetupBarrierSim.SecondTargetBar = this.TargetRight.transform.position;
						this.TargetBRight.FistTarget = false;
					
					}else
					{
						auxSim.SetupBarrierSim.FirstTargetBar = this.TargetRight.transform.position;
						this.TargetBRight.FistTarget = true;
						auxSim.SetupBarrierSim.SecondTargetBar = this.TargetLeft.transform.position;
						this.TargetBLeft.FistTarget = false;
					}
					
					// Setup first target only
					auxSim.SetupBarrierSim.IsHasSetFirstTargetBar = true; 
					auxSim.SetupBarrierSim.IsReachFirstTargetBar = false; 
					
					// Second target not setup
					auxSim.SetupBarrierSim.IsHasSetSecondTargetBar = false; 
					auxSim.SetupBarrierSim.IsReachSecondTargetBar = false;
					
				}				
				
			}
			
		}
	}
}
