using UnityEngine;
using System.Collections;

public class FallObject : MonoBehaviour 
{
	
	public bool IsFall = false; 
	public float Speed;
	public float InitAcceleration = 5.0f;
	private Vector3 positionObject;
	public GameObject InteractiveIcon;
	private bool endFall = false;
	private bool checkHit = true;
	
	public float YMax;
	public float ZPosition;
	
	public GameObject ParticleCloud;
	public float DelayParticle;
	private float timeUpdateParticle = 0.0f;
	private GameObject instPC;


    /// <summary>
    /// Offset to setup raycast of object
    /// </summary>
    public float offsetSideRaycastLeft = 0.0f;
    public float offsetSideRaycastRigth = 0.0f;

	/// <summary>
	/// Sound for brick when click
	/// </summary>
	public AudioClip FallSound;

	// Use this for initialization
	void Start () 
	{		
		this.positionObject = this.transform.position;
		this.positionObject.z = this.ZPosition;
		this.transform.position = this.positionObject;
	
	}
	
	// Update is called once per frame
	void Update () 
	{
		if (this.IsFall)
		{			
			if (!this.endFall)
			{
				if (this.transform.position.y > this.YMax)
				{
					this.positionObject.y += (Vector3.down.y * this.Speed * this.InitAcceleration *  Time.deltaTime);
					this.transform.position = this.positionObject;
					this.InitAcceleration  += Time.deltaTime;
					
					if (this.checkHit)
					{
                        // Raycast for objects
                        RaycastHit hitLeft;
                        Vector3 auxVecHitLeft = this.transform.position;
                        auxVecHitLeft.x -= this.offsetSideRaycastLeft;
                        bool isHittingLeft = Physics.Raycast(auxVecHitLeft, Vector3.down, out hitLeft, 25.0f);

                        RaycastHit hitRight;
                        Vector3 auxVecHitRigth = this.transform.position;
                        auxVecHitRigth.x += this.offsetSideRaycastRigth;
                        bool isHittingRigth = Physics.Raycast(auxVecHitRigth, Vector3.down, out hitRight, 25.0f);


                        //RaycastHit hit;
						//if( Physics.Raycast( this.transform.position, Vector3.down, out hit, 25.0f ) )
                        if( isHittingLeft ||  isHittingRigth)
						{
                            RaycastHit hit = new RaycastHit();
                            if (isHittingLeft)
                            {
                                hit = hitLeft;
                            }
                            else if (isHittingRigth)
                            {
                                hit = hitRight;
                            }
                        
							if ((hit.transform.gameObject.layer == LayerMask.NameToLayer("bodyCollider")) && 
								(hit.transform.parent.transform.position.z <= -10.0f) && 
								(hit.transform.parent.transform.position.z >= -38.0f))
							{
								
								if (hit.transform.parent.GetComponent<SimController>().Stunned())
								{
									
									this.endFall = true;
									Vector3 auxPos = this.transform.position;
									auxPos.x += 0.0f;
									auxPos.y -= 30.0f;
									auxPos.z -= 10.0f;
									this.instPC = GameObject.Instantiate(this.ParticleCloud,auxPos,Quaternion.identity) as GameObject;
									MeshRenderer render = this.transform.GetComponent<MeshRenderer>();
									render.enabled = false;
								}else
								{
									
									this.checkHit = false;	
								}
								
							}
						}
					}
					
				}else
				{
					this.positionObject.y = this.YMax;
					this.transform.position = this.positionObject;					
					Vector3 auxPos = this.transform.position;
					auxPos.x += 0.0f;
					auxPos.y -= 30.0f;
					auxPos.z -= 10.0f;
					this.instPC = GameObject.Instantiate(this.ParticleCloud,auxPos,Quaternion.identity) as GameObject;
					MeshRenderer render = this.transform.GetComponent<MeshRenderer>();
					render.enabled = false;
					this.endFall = true;
					
				}
			}else
			{
				this.timeUpdateParticle += Time.deltaTime;
				if (this.timeUpdateParticle >= this.DelayParticle)
				{
					Destroy(this.instPC);
					Destroy(this.transform.gameObject);
					
				}
				
			}
		}
		
	
	}
	
	void OnItemClick()
	{
		if (!this.IsFall)
		{
			this.IsFall = true;
			if (this.InteractiveIcon != null)
			{
				Destroy(this.InteractiveIcon);	
				
			}
			GameManager.Instance.Sound_Manager.PlaySoundEffect(this.FallSound);
		}
	}


    void OnDrawGizmos()
    {
        Gizmos.color = Color.yellow;
        Vector3 auxVecHitLeft = transform.position;
        auxVecHitLeft.x -= offsetSideRaycastLeft;
        Gizmos.DrawLine(auxVecHitLeft, auxVecHitLeft + Vector3.down * 25.0f);


        Vector3 auxVecHitRigth = transform.position;
        auxVecHitRigth.x += offsetSideRaycastRigth;
        Gizmos.DrawLine(auxVecHitRigth, auxVecHitRigth + Vector3.down * 25.0f);
    }
		
}
