﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Init : MonoBehaviour {
	
	
	// Use this for initialization
	void Awake () {
		
		bool platformChanged = false;
		//PlatformChanged(); // tell the editor things have changed
		//tk2dEditorUtility.UnloadUnusedAssets();

        float maxValue = Mathf.Max(Screen.width, Screen.height);
        /*
        if (1920 <= maxValue)
		{
			tk2dSystem.CurrentPlatform = "2x";
			platformChanged = true;
		}
        else if (1280 <= maxValue)
		{
			tk2dSystem.CurrentPlatform = "2x";
			platformChanged = true;
		}
        else */if (1024 <= maxValue)
		{
			tk2dSystem.CurrentPlatform = "2x";
			platformChanged = true;
		}
		else// if( Screen.width <= 800 )
		{
			tk2dSystem.CurrentPlatform = "1x";
		}
		
		PlatformChanged();
		/*
		if(platformChanged)
		{
			PlatformChanged();
		}
		else
		{
			string d = tk2dSystem.CurrentPlatform;
			//esto es necesairo cuando se esta desarrollando y las preferencias son x defecto 2x
			if( tk2dSystem.CurrentPlatform == "2x" )
			{
				tk2dSystem.CurrentPlatform = "1x";
				PlatformChanged();
			}
		}*/
			
		// Setup sound
		GameSettings.SetSoundEffecttk2d();
		
	}
	public static void PlatformChanged()
	{
		List<tk2dSpriteCollectionData> changedSpriteCollections = new List<tk2dSpriteCollectionData>();
		tk2dSpriteCollectionData[] allSpriteCollections = Resources.FindObjectsOfTypeAll(typeof(tk2dSpriteCollectionData)) as tk2dSpriteCollectionData[];
		foreach (tk2dSpriteCollectionData scd in allSpriteCollections)
		{
			if (scd.hasPlatformData)
			{
				scd.ResetPlatformData();
				changedSpriteCollections.Add(scd);
			}
		}
		allSpriteCollections = null;

		tk2dFontData[] allFontDatas = Resources.FindObjectsOfTypeAll(typeof(tk2dFontData)) as tk2dFontData[];
		foreach (tk2dFontData fd in allFontDatas)
		{
			if (fd.hasPlatformData)
			{
				fd.ResetPlatformData();
			}
		}
		allFontDatas = null;

		if (changedSpriteCollections.Count == 0)
			return; // nothing worth changing has changed

		// Scan all loaded sprite assets and rebuild them
		foreach (var assembly in System.AppDomain.CurrentDomain.GetAssemblies())
		{
			try
			{
				System.Type[] types = assembly.GetTypes();
				foreach (var type in types)
				{
					if (type.GetInterface("tk2dRuntime.ISpriteCollectionForceBuild") != null)
					{
						Object[] objects = Resources.FindObjectsOfTypeAll(type);

						foreach (var spriteCollectionData in changedSpriteCollections)
						{
							foreach (var o in objects)
							{

								tk2dRuntime.ISpriteCollectionForceBuild isc = o as tk2dRuntime.ISpriteCollectionForceBuild;
								if (isc.UsesSpriteCollection(spriteCollectionData))
									isc.ForceBuild();
							}
						}
					}
				}
			}
			catch { }
		}
	}
}
