﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class SoundManager : MonoBehaviour 
{
	
	public Camera guiCamera;
	private AudioSource musicSource;
	public AudioClip CurrentMusic;
	
	void Start () 
	{
		guiCamera = GUICamera.instanceCamera;
		this.musicSource = this.guiCamera.transform.GetComponent<AudioSource>();
		
	}
	
	void Update (){}

	public void PlayMusic(AudioClip clip)
	{		
		if ((this.musicSource != null) && (clip != null) )
		{
			this.CurrentMusic = clip;
			this.musicSource.clip = this.CurrentMusic;
			this.musicSource.loop = true;
			if (!GameSettings.MuteMusic)
			{
				this.musicSource.Play();
			}
		}
	}
	
	public void PauseMusic()
	{
		if (this.musicSource != null)
		{
			if (this.musicSource.clip != null)
			{
				this.musicSource.Pause();	
			}
		}	
	}
	
	public void ResumeMusic()
	{
		if (this.musicSource != null)
		{
			if (this.musicSource.clip != null)
			{
				this.musicSource.Play();	
				
			}
		}
	}

	public void PlaySoundEffect(AudioClip soundEffect)
	{
		if ((this.musicSource != null) && (soundEffect != null) && (!GameSettings.isMuteSoundEffects))
		{
			this.musicSource.PlayOneShot(soundEffect,GameSettings.VolumenSoundEffect);
		}
	}

}
