using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;
using System.IO;

public class StartUp : MonoBehaviour 
{
  
	void Awake()
	{
		string auxConfig;
		// Setup device
		auxConfig = "Set up project\n  Device Type: ";
		
		if (SystemInfo.deviceType == DeviceType.Desktop)
		{
			GameSettings.GameDeviceType = GameSettings.DeviceType.DESKTOP_DEVICE;	
			auxConfig += "Mouse";
			
		}else if (SystemInfo.deviceType == DeviceType.Handheld)
		{
			
			GameSettings.GameDeviceType = GameSettings.DeviceType.TACTILE_DEVICE;	
			
			auxConfig += "Touch";
		}else
		{
			GameSettings.GameDeviceType = GameSettings.DeviceType.DESKTOP_DEVICE;	
			auxConfig += "Mouse";
		}
		
		
		auxConfig += "\n Language: ";
		switch( Application.systemLanguage)
		{
			
			case SystemLanguage.Spanish:
				
				GameSettings.GameLanguage = GameSettings.Language.SPANISH;	
				auxConfig += "Spanish";
			
			break;
			
			case SystemLanguage.English:
				
				GameSettings.GameLanguage = GameSettings.Language.ENGLISH;	
				auxConfig += "English";
			
			break;
			
			case SystemLanguage.Japanese:
				
				GameSettings.GameLanguage = GameSettings.Language.JAPANESE;	
				auxConfig += "Japanese";
			
			break;
			
			case SystemLanguage.Chinese:
				
				GameSettings.GameLanguage = GameSettings.Language.CHINESE;	
				auxConfig += "Chinese";
			
			break;
			
			case SystemLanguage.Korean:
				
				GameSettings.GameLanguage = GameSettings.Language.KOREAN;	
				auxConfig += "Korean";
			
			break;
		}
		
		
		auxConfig += "\n Internet Connection: ";
		if (Application.internetReachability == NetworkReachability.ReachableViaLocalAreaNetwork)
		{
			auxConfig += "Wifi or Cable";
			GameSettings.GameConnectionType = GameSettings.ConnectionType.DSL_LAN_CONNECTION;
			
		}
		
		if (Application.internetReachability == NetworkReachability.NotReachable)
		{
			auxConfig += "No internet";
			GameSettings.GameConnectionType = GameSettings.ConnectionType.NO_CONNECTION;
			
		}
	
	}
	
	// Use this for initialization
	void Start () 
	{
		
	}
	
	
}
