﻿using UnityEngine;
using System.Collections;

public class CatAttacher : MonoBehaviour {
	
	public GameObject cat;
	public float offsetYHead = -20;
	
	private Spine.Bone bone;
	
	private bool parentAssigned = false;
	// Use this for initialization
	void Start () {
		SkeletonAnimation skeletonAnimation = GetComponent<SkeletonAnimation>();
		bone = skeletonAnimation.skeleton.FindBone( "bone_headAttach" );
	}
	
	// Update is called once per frame
	void Update () {
		
		if( cat != null )
		{
			if( !parentAssigned )
			{
				cat.transform.parent = transform;
			}
			if( Mathf.Approximately(transform.rotation.eulerAngles.y, 180) )
			{
				cat.transform.position = new Vector3(-bone.WorldX + transform.position.x, bone.WorldY + transform.position.y + offsetYHead, transform.position.z);
				
				//La Z tiene que especificarse en la posicion local ya que en la global si tiene velocidad en Z, el sim podria superponerse al gato.
				cat.transform.localPosition = new Vector3(cat.transform.localPosition.x, cat.transform.localPosition.y, 0.001f);
				//cat.transform.rotation = Quaternion.AngleAxis(-bone.WorldRotation+90,Vector3.forward);
			}
			else
			{
				cat.transform.position = new Vector3(bone.WorldX + transform.position.x, bone.WorldY + transform.position.y + offsetYHead, transform.position.z);
				
				//La Z tiene que especificarse en la posicion local ya que en la global si tiene velocidad en Z, el sim podria superponerse al gato.
				cat.transform.localPosition = new Vector3(cat.transform.localPosition.x, cat.transform.localPosition.y, -0.001f);
			}

			cat.transform.rotation = Quaternion.Euler( cat.transform.rotation.eulerAngles.x, transform.rotation.eulerAngles.y, bone.WorldRotation-90);
			
		}
	}
	
	public void AttachCat(GameObject cat)
	{
		this.cat = cat;
	}
}
