using UnityEngine;
using System.Collections;

public class Bird : MonoBehaviour {
	
	public GameObject fx_feather;
	public GameObject coin;
	
	[System.NonSerialized]
	public float minX;
	[System.NonSerialized]
	public float maxX;
	
	private SkeletonAnimation skeletonAnim;
	
	public float speed = 350;
	public float dir 	= 1;
	
	private Vector3 currentSpeed;
	private bool touched = false;
	
	public float speedY		= 200;
	public float variationY = 75;
	private float targetY;
	private int dirY = -1;

    public AudioClip pio;
    public AudioClip explosionBird;

	// Use this for initialization
	void Start () {
		skeletonAnim = transform.GetChild(0).GetComponent<SkeletonAnimation>();
		targetY = transform.position.y + variationY*dirY;

       // GameManager.Instance.Sound_Manager.PlaySoundEffect(pio);
        
	}
	
	// Update is called once per frame
	void Update ()
	{
		if( !touched )
		{
			if(dirY < 0 && transform.position.y < targetY || 0 < dirY && targetY < transform.position.y)
			{
				dirY *= -1;
				targetY = transform.position.y + variationY*dirY;
			}
			
			transform.position += Vector3.right*dir*speed*Time.deltaTime + Vector3.up*dirY*speedY*Time.deltaTime;
			
			
			if( dir < 0 && transform.position.x < minX - 100 || 0 < dir && maxX + 100 < transform.position.x )
			{
				Destroy(gameObject);
			}
		}
	}
	
	void OnTouch()
	{
		if( 0 < Time.timeScale && !GameManager.Instance.GameStats.EndLevel  )
		{
			touched = true;
		
			skeletonAnim.animationName = "explode";
			skeletonAnim.timeScale = 0.5f;
			StartCoroutine(TimerDie());

            GameManager.Instance.Sound_Manager.PlaySoundEffect(explosionBird);

		}
	
		
	}
	
	IEnumerator TimerDie()
	{
		
		yield return new WaitForSeconds(0.5f);
		SpawnBrokenEffect();
		SpawnCoins();
		Destroy( gameObject);
	}
	
	void SpawnBrokenEffect()
	{
		Feather featherAux;
		
		Vector3 randomPos;
		
		
		for(int i=0;i<4;i++)
		{
			randomPos = transform.position + Vector3.right*Random.Range(-5,5)*5 + Vector3.up*Random.Range(-5,5)*5;
			
			featherAux = ((GameObject)GameObject.Instantiate( fx_feather, randomPos,Quaternion.identity)).GetComponent<Feather>();
			
			float randomRotation = Random.Range(0,2);
			if( 0 < randomRotation )
			{
				featherAux.transform.rotation = Quaternion.AngleAxis( 180, Vector3.up );
			}
			
			if( 1 < i )
			{
				featherAux.dir = 1;
			}
			else
			{
				featherAux.dir = -1;
			}
			
		}
	}
	
	void SpawnCoins()
	{
		CoinInteractiveCity coinScript;
		
		for(int i = 0; i < 2; i++)
		{
			coinScript = ((GameObject)GameObject.Instantiate( coin, transform.position, Quaternion.identity )).GetComponent<CoinInteractiveCity>();
			if( 0 < i )
			{
				coinScript.directionSpawn = 1;
			}
			else
			{
				coinScript.directionSpawn = -1;
			}
		}
	}
}
