using UnityEngine;
using System.Collections;

public class BirdsSpawner : MonoBehaviour {

	public float initialDelaySpawn = 5f;
	public float delaySpawn = 6f;
	
	//public GameObject bird01prefab;
	public GameObject[] birdsPrefab;
	
	public int maxCount = 3;
	private int currentCount = 0;
	
	private float minX;
	private float maxX;
	
	private bool canSpawn = false;
	
	
	// Use this for initialization
	void Start () {
		minX = CameraController.minX - 150;
		maxX = CameraController.maxX + 150;
		StartCoroutine( TimerDelaySpawn(initialDelaySpawn) );
	}
	
	// Update is called once per frame
	void Update ()
	{
		if( canSpawn && currentCount < maxCount)
		{
			canSpawn = false;
			currentCount++;
			SpawnBird();
			StartCoroutine( TimerDelaySpawn(delaySpawn) );
		}
	}
	
	IEnumerator TimerDelaySpawn(float sec)
	{
		yield return new WaitForSeconds( sec );
		canSpawn = true;
	}
	
	void SpawnBird()
	{
		Bird newBird;
		
		int randomDir = Random.Range(0,2);
		if( randomDir == 0 )
		{
			randomDir = -1;
		}
		
		Vector3 randomPos;

		if( GameManager.Instance.SetupInitLevel.VariousHeights )
		{
			randomPos = new Vector3(0,300+Random.Range(0,7)*15 + 100,GameManager.Instance.SimSetupSettings.FarZ - 255);
		}
		else
		{
			randomPos = new Vector3(0,300+Random.Range(0,7)*15,GameManager.Instance.SimSetupSettings.FarZ - 255);
		}
		
		if( randomDir < 0 )
		{
			randomPos.x = maxX + 100;
		}
		else
		{
			randomPos.x = minX - 100;
		}
		
		//GameObject.Instantiate( bird01, randomPos, Quaternion.identity );
		int randomIndex = Random.Range(0, birdsPrefab.Length);
		newBird = ((GameObject)Instantiate( birdsPrefab[Random.Range(0, birdsPrefab.Length)], randomPos, Quaternion.identity )).GetComponent<Bird>();
		
		if( 0 < randomDir)
		{
			newBird.transform.rotation = Quaternion.AngleAxis(180, Vector3.up);
		}
		newBird.dir = randomDir;
		newBird.minX = minX;
		newBird.maxX = maxX;
		
		
	}
}
