﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class CatMachineController : MonoBehaviour {
	
	public float distancePortrait = 0.25f;
	
	[System.SerializableAttribute]
	public class CatTypePrefab
	{
		public GameObject baseCat;
		public GameObject loveCat;
		public GameObject tripleCat;
		public GameObject duplicatorCat;
		public GameObject speedCat;
		public GameObject bombCat;
	}
	public CatTypePrefab catTypePrefab;
	public List<GameObject> catList;
	public GameObject[] catListForniture;
	
	public List<tk2dTextMesh> textCountCatList;
	
	
	
	public GameObject dragCatIconHelper;
	//public GameObject loveArrowHelper;
	
	public int indexColumnCat = 0;
	protected bool firstTime = true;
	
	protected int[] indexCatType = new int[]{-1,-1,-1,-1,-1,-1};
	
	protected bool setupFinishedLevel = false;
	
	public enum CatTypeID : int{
		BaseCat = 0,
		LoveCat = 1,
		TripleCat = 2,
		DuplicatorCat = 3,
		SpeedCat	= 4,
		bombCat		= 5,
	}
	
	protected List<CatTypeID> listCatTypes = new List<CatTypeID>();
	

	
	// Update is called once per frame
	void Update () {
		if( firstTime )
		{
			firstTime = false;
			UpdateCatCount();
		}
		if( GameManager.Instance.GameStats.EndLevel && !setupFinishedLevel)
		{
			setupFinishedLevel = true;
			for (int i = 0; i < 5; i++) {
				textCountCatList[i].gameObject.SetActive(false);
			}
		}
	}
	/*
	void InstantiateCat(GameObject cat, CatTypeID catTypeId, int countCats)
	{
		DragDropCatController dragCatController	= ((GameObject)GameObject.Instantiate( cat, catList[indexColumnCat].transform.position, Quaternion.identity )).GetComponent<DragDropCatController>();
		dragCatController.gameObject.transform.parent = catList[indexColumnCat].transform;
		dragCatController.Initialize( dragCatIconHelper, this, indexColumnCat );
		
		
		textCountCatList[indexColumnCat].gameObject.SetActive(true);
		
		indexCatType[indexColumnCat] = (int)catTypeId;
		
		if( 1 < countCats )
		{
			SetupFornitureCats( catTypeId, countCats );
		}
		
		
		if( (int)catTypeId == (int)CatTypeID.LoveCat )
		{
			(dragCatController as DragDropLoveCatController).loveArrowHelper = loveArrowHelper;
		}
		
		indexColumnCat++;
		
	}*/
	
	void SetupFornitureCats( CatTypeID catID, int countCats )
	{
		//IPD20131224 Como el boton del gato ya cuenta como uno en el contador de gatos le descuento ese boton.
		//Si hay 3 gatos habra 1 boton y 2 portraits decorativos
		countCats--;
		
		if( 4 < countCats )
		{
			countCats = 4;
		}
		for (int i = 0; i < countCats; i++)
		{
			catListForniture[4*indexColumnCat+i].SetActive(true);
			tk2dSprite spriteCatForniture = catListForniture[4*indexColumnCat+i].GetComponent<tk2dSprite>();
			spriteCatForniture.SetSprite( spriteCatForniture.GetSpriteIdByName( "portrait"+catID.ToString() ) );
		}
	}
	
	void UpdateCatCount()
	{
		//esto esta mal
		for (int i = 0; i < listCatTypes.Count; i++)
		{
			switch(listCatTypes[i])
			{
				case CatTypeID.BaseCat:
					textCountCatList[i].text = "" + GameManager.Instance.SettingCats.CurrentBaseCat;
					break;
				case CatTypeID.LoveCat:
					textCountCatList[i].text = "" + GameManager.Instance.SettingCats.CurrentLoveCat;
					break;
				case CatTypeID.TripleCat:
					textCountCatList[i].text = "" + GameManager.Instance.SettingCats.CurrentTripleCat;
					break;
			}
		}
		//textCountCatList[0].text = "" + GameManager.Instance.SettingCats.CurrentBaseCat;
		//textCountCatList[1].text = "" + GameManager.Instance.SettingCats.CurrentLoveCat;
	}

	public void UpdateCatCount( int index )
	{
		
		textCountCatList[index].text = ""+(int.Parse(textCountCatList[index].text) - 1);
		if( int.Parse(textCountCatList[index].text) == 0 )
		{
			///...
		}
	}
	
	void OnDrawGizmos()
	{
		/*
		Gizmos.color = Color.yellow;
		for(int i =0;i<5;i++)
		{
			Gizmos.DrawSphere( rootCat.transform.position - Vector3.right*i*distancePortrait, 0.05f );
		}*/
	}
}
