﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class CatMachineControllerArcade : CatMachineController {
	
	void Start () {
		if( GameManager.Instance.SettingCats.BaseCat > 0 )
		{
			listCatTypes.Add(CatTypeID.BaseCat);
			InstantiateCat( catTypePrefab.baseCat, CatTypeID.BaseCat, GameManager.Instance.SettingCats.BaseCat );
		}
		if( GameManager.Instance.SettingCats.LoveCat > 0 )
		{
			listCatTypes.Add(CatTypeID.LoveCat);
			InstantiateCat( catTypePrefab.loveCat, CatTypeID.LoveCat, GameManager.Instance.SettingCats.LoveCat );
		}
		if( GameManager.Instance.SettingCats.TripleCat > 0 )
		{
			listCatTypes.Add(CatTypeID.TripleCat);
			InstantiateCat( catTypePrefab.tripleCat, CatTypeID.TripleCat, GameManager.Instance.SettingCats.TripleCat );
		}
		if( GameManager.Instance.SettingCats.DuplicatorCat > 0 )
		{
			listCatTypes.Add(CatTypeID.DuplicatorCat);
			InstantiateCat( catTypePrefab.duplicatorCat, CatTypeID.DuplicatorCat, GameManager.Instance.SettingCats.DuplicatorCat );
		}
	}
	// Update is called once per frame
	void Update () {
		if( firstTime )
		{
			firstTime = false;
			UpdateCatCount();
		}
		if( GameManager.Instance.GameStats.EndLevel && !setupFinishedLevel)
		{
			setupFinishedLevel = true;
			for (int i = 0; i < 5; i++) {
				textCountCatList[i].gameObject.SetActive(false);
			}
		}
	}
	
	void InstantiateCat(GameObject cat, CatTypeID catTypeId, int countCats)
	{
		DroppableBaseCat dragCatController	= ((GameObject)GameObject.Instantiate( cat, catList[indexColumnCat].transform.position, Quaternion.identity )).GetComponent<DroppableBaseCat>();
		dragCatController.gameObject.transform.parent = catList[indexColumnCat].transform;
		dragCatController.Initialize( dragCatIconHelper, this, indexColumnCat );
		
		
		textCountCatList[indexColumnCat].gameObject.SetActive(true);
		
		indexCatType[indexColumnCat] = (int)catTypeId;
		
		if( 1 < countCats )
		{
			SetupFornitureCats( catTypeId, countCats );
		}
		
		/*
		if( (int)catTypeId == (int)CatTypeID.LoveCat )
		{
			(dragCatController as DroppableLoveCat).loveArrowHelper = loveArrowHelper;
		}*/
		
		indexColumnCat++;
		
	}
	
	void SetupFornitureCats( CatTypeID catID, int countCats )
	{
		//IPD20131224 Como el boton del gato ya cuenta como uno en el contador de gatos le descuento ese boton.
		//Si hay 3 gatos habra 1 boton y 2 portraits decorativos
		countCats--;
		
		if( 4 < countCats )
		{
			countCats = 4;
		}
		for (int i = 0; i < countCats; i++)
		{
			catListForniture[4*indexColumnCat+i].SetActive(true);
			tk2dSprite spriteCatForniture = catListForniture[4*indexColumnCat+i].GetComponent<tk2dSprite>();
			spriteCatForniture.SetSprite( spriteCatForniture.GetSpriteIdByName( "portrait"+catID.ToString() ) );
		}
	}
	
	void UpdateCatCount()
	{
		//esto esta mal
		for (int i = 0; i < listCatTypes.Count; i++)
		{
			switch(listCatTypes[i])
			{
				case CatTypeID.BaseCat:
					textCountCatList[i].text = "" + GameManager.Instance.SettingCats.CurrentBaseCat;
					break;
				case CatTypeID.LoveCat:
					textCountCatList[i].text = "" + GameManager.Instance.SettingCats.CurrentLoveCat;
					break;
				case CatTypeID.TripleCat:
					textCountCatList[i].text = "" + GameManager.Instance.SettingCats.CurrentTripleCat;
					break;
			}
		}
		//textCountCatList[0].text = "" + GameManager.Instance.SettingCats.CurrentBaseCat;
		//textCountCatList[1].text = "" + GameManager.Instance.SettingCats.CurrentLoveCat;
	}

	public void UpdateCatCount( int index )
	{
		
		textCountCatList[index].text = ""+(int.Parse(textCountCatList[index].text) - 1);
		if( int.Parse(textCountCatList[index].text) == 0 )
		{
			///...
		}
	}
	
	void OnDrawGizmos()
	{
		/*
		Gizmos.color = Color.yellow;
		for(int i =0;i<5;i++)
		{
			Gizmos.DrawSphere( rootCat.transform.position - Vector3.right*i*distancePortrait, 0.05f );
		}*/
	}
}
