using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class CatMachineControllerCampaign : CatMachineController {
	
	public Transform tubeParent;
	private Transform tube;
	
	public int maxCats = 6;
	
	public Transform[] tubePoints;
	public Transform dragPoint;

	CatHelper catHelper;

	public static CatMachineControllerCampaign  Instance;

	void Awake()
	{
		Instance = this;
	}

	void Start () {

		catHelper = GetComponent<CatHelper>();

		indexColumnCat = -1;
		
		//GameManager.Instance.SettingCats.TypeCat typeCatGameManager;
		
		for (int i = 0; i < GameManager.Instance.SettingCats.CatCampaingLevel.Length; i++) {
			
			switch( GameManager.Instance.SettingCats.CatCampaingLevel[i] )
			{
				case GameManager.Cats.TypeCat.BASE_CAT:
					listCatTypes.Add(CatTypeID.BaseCat);
					if( indexColumnCat < 0 )
					{
						InstantiateFirstCat( catTypePrefab.baseCat, CatTypeID.BaseCat );
					}
					else
					{
						InstantiateCat( catTypePrefab.baseCat, CatTypeID.BaseCat );
					}
					break;
				case GameManager.Cats.TypeCat.LOVE_CAT:
					listCatTypes.Add(CatTypeID.LoveCat);
					if( indexColumnCat < 0 )
					{
						InstantiateFirstCat( catTypePrefab.loveCat, CatTypeID.LoveCat );
					}
					else
					{
						InstantiateCat( catTypePrefab.loveCat, CatTypeID.LoveCat);
					}
					break;
				case GameManager.Cats.TypeCat.TRIPLE_CAT:
					listCatTypes.Add(CatTypeID.TripleCat);
					if( indexColumnCat < 0 )
					{
						InstantiateFirstCat( catTypePrefab.tripleCat, CatTypeID.TripleCat );
					}
					else
					{
						InstantiateCat( catTypePrefab.tripleCat, CatTypeID.TripleCat );
					}
					break;
				case GameManager.Cats.TypeCat.DUPLICATOR_CAT:
					listCatTypes.Add(CatTypeID.DuplicatorCat);
					if( indexColumnCat < 0 )
					{
						InstantiateFirstCat( catTypePrefab.duplicatorCat, CatTypeID.DuplicatorCat );
					}
					else
					{
						InstantiateCat( catTypePrefab.duplicatorCat, CatTypeID.DuplicatorCat );
					}
					break;
				case GameManager.Cats.TypeCat.SPEED_CAT:
					listCatTypes.Add(CatTypeID.SpeedCat);
					if( indexColumnCat < 0 )
					{
						InstantiateFirstCat( catTypePrefab.speedCat, CatTypeID.SpeedCat );
					}
					else
					{
						InstantiateCat( catTypePrefab.speedCat, CatTypeID.SpeedCat );
					}
					break;
				case GameManager.Cats.TypeCat.BOMB_CAT:
					listCatTypes.Add(CatTypeID.bombCat);
					if( indexColumnCat < 0 )
					{
						InstantiateFirstCat( catTypePrefab.bombCat, CatTypeID.bombCat );
					}
					else
					{
					InstantiateCat( catTypePrefab.bombCat, CatTypeID.bombCat );
					}
				break;
			}
		}
		
		
		//Se mueve el tubo hacia la izquierda dependiendo del numero de gatos que falte para llenar todo el tubo.
		tube = tubeParent.GetChild(0);
		tube.position = new Vector3( tube.position.x-55*(5-indexColumnCat), tube.position.y, tube.position.z );
		
	}
	// Update is called once per frame
	void Update () {
	

		if( DroppableBaseCat.IS_DRAGGING )
		{
			dragPoint.parent.animation.Stop();
		}
		else if( !dragPoint.animation.isPlaying && 	0 <= indexColumnCat  )
		{
			dragPoint.parent.animation.Play("exitMachineIdle");
		}


		if( GameManager.Instance.GameStats.EndLevel && !setupFinishedLevel)
		{
			setupFinishedLevel = true;
			//for (int i = 0; i < 5; i++) {
			//	textCountCatList[i].gameObject.SetActive(false);
			//}
		}
	}



	void InstantiateFirstCat(GameObject cat, CatTypeID catTypeId)
	{
		DroppableBaseCat dragCatController	= ((GameObject)GameObject.Instantiate( cat, dragPoint.transform.position, Quaternion.identity )).GetComponent<DroppableBaseCat>();
		dragCatController.gameObject.transform.parent = dragPoint.transform;
		dragCatController.Initialize( dragCatIconHelper, this, indexColumnCat );
		
		
		/*
		if( (int)catTypeId == (int)CatTypeID.LoveCat )
		{
			(dragCatController as DroppableLoveCat).loveArrowHelper = loveArrowHelper;
		}*/
		
		indexColumnCat++;
	}
	void InstantiateCat(GameObject cat, CatTypeID catTypeId)
	{
		DroppableBaseCat dragCatController	= ((GameObject)GameObject.Instantiate( cat, tubePoints[indexColumnCat].transform.position, Quaternion.identity )).GetComponent<DroppableBaseCat>();
		dragCatController.gameObject.transform.parent = tubePoints[indexColumnCat].transform;
		dragCatController.Initialize( dragCatIconHelper, this, indexColumnCat );
		
		//Ya que este metodo se llama para lso gatos que no son el primero, estan ene l tubo por lo tanto no se podran usar hasta que no esten en la primera posicion de la lista
		dragCatController.isInTube = true;
		/*
		if( (int)catTypeId == (int)CatTypeID.LoveCat )
		{
			(dragCatController as DroppableLoveCat).loveArrowHelper = loveArrowHelper;
		}*/
		
		indexColumnCat++;
	}
	
	public void MoveNextCat()
	{
		if( 0 < indexColumnCat )
		{
			tubeParent.animation.Play("tubeVibrate");
			dragPoint.parent.animation.Play("exitMachineNextCat");
			for( int i = 0; i<indexColumnCat ;i++ )
			{
				tubePoints[i].animation.Play( "nextSlotTube0"+(i+1) );
				tubePoints[i].animation.Play( "nextSlotTube0"+(i+1) );
				tubePoints[i].GetChild(0).localPosition = Vector3.zero;
			}

            

			StartCoroutine( TimerSetParents() );
			
		}
		else
		{
			dragPoint.parent.animation.Play("exitMachineHide");
            indexColumnCat--;
            
            //TutorialCirclePutCatHere.NextCircle();
		}

       
	}
	
	IEnumerator TimerSetParents()
	{
		//0.65f son los segundos que duran las animaciones de desplazamiento en el tubo, despues de las animaciones se asignan los nuevos padres
		yield return new WaitForSeconds(0.3f);
		dragPoint.animation.Play("slotExitNextCat");
		
		for( int i = 0; i<indexColumnCat ;i++ )
		{
			if( i == 0 )
			{
				//tubePoints[0].GetChild(0).position = dragPoint.position;
				tubePoints[0].GetChild(0).GetComponent<DroppableBaseCat>().isInTube = false;
				tubePoints[0].GetChild(0).parent = dragPoint;
				dragPoint.GetChild(0).localPosition = Vector3.zero;
				dragPoint.GetChild(0).localScale = new Vector3(1,1,1);
			}
			else
			{
				tubePoints[i].GetChild(0).parent = tubePoints[i-1];
			}
		}
		indexColumnCat--;

		catHelper.UpdateTutorial();

        /*if (TutorialCirclePutCatHere.Instance != null)
        {
            TutorialCirclePutCatHere.Instance.NextCircle();
        }*/
	}
	

}
