using UnityEngine;
using System.Collections;

public class DroppableBaseCat : MonoBehaviour {
	
	
	
	/// <summary>
	/// Prefab object that will be instantiated on the DragDropSurface if it receives the OnDrop event.
	/// </summary>
	public GameObject helperIcon;
	
	public GameObject prefab;
	
	public static bool IS_DRAGGING = false;
	public static GameObject greenFloor;
	public GreenFloorHelper greenFloorScript;
	
	
	protected  Vector3 initialPosition;
	
	protected Transform mTrans;
	protected bool mIsDragging = false;
	
	//bool mSticky = false;
	
	//Transform mParent;
	
	//protected GameObject cameraGUI;
	
	protected bool firstTime = true;
	
	protected Vector3 initialPos;
	
	protected float heightFloor = 180;
	
	/// <summary>
	/// The index bar. Es el indice de la barra del machine cat en la que esta (si esta en la primera barra sera 0, si esta en la segunda sera 1,..)
	/// </summary>
	protected int indexBar = -1;
	protected CatMachineControllerCampaign cMCCampaign;
	protected CatMachineControllerArcade cMCArcade;
	
	protected tk2dUIDragItem dragItemScript;
	
	//[System.NonSerializedAttribute]
	public bool isInTube = false;
	
	protected Transform target;

	public static Vector3 currentPosition;

	public enum TypeCat
	{
		BASE,
		BOMB,
		TRIPLE,
		LOVE,
		SPEED,
		DUPLICATOR,
	}

	public static TypeCat typeCatOnMachine 	= TypeCat.BASE;
	public TypeCat currentTypeCat 			= TypeCat.BASE;

	private tk2dSprite sprite;


	void Awake()
	{
		
	}

	void Start()
	{
		Initialize();
	}
	
	public void Initialize()
	{
		dragItemScript = GetComponent<tk2dUIDragItem>();
		
		//cameraGUI = GameObject.Find("GUICamera");
		if( greenFloor == null )
		{
			greenFloor = GameObject.Find("GreenFloor");
			greenFloor.SetActive(false);
		}
		else
		{
			greenFloorScript = greenFloor.GetComponent<GreenFloorHelper>();
		}
		
		target = transform.GetChild(0);
		
		//GetComponent<tk2dUIDragItem>().isBtnActive
		
		Vector3  positionScreen = GUICamera.instanceCamera.camera.WorldToScreenPoint(transform.position);
		initialPos = Camera.main.ScreenToWorldPoint(positionScreen);
		
		if( helperIcon == null )
		{
			//helperIcon = transform.parent.FindChild("dragDropCatIcon").gameObject;
		}
		
		collider.enabled = false;
		StartCoroutine( TimerActive() );
	}
	
	public void Initialize( GameObject helperIcon, CatMachineControllerCampaign catMachineController, int indexBar )
	{
		this.helperIcon = helperIcon;
		cMCCampaign 	= catMachineController;
		this.indexBar  	= indexBar;
	}
	
	public void Initialize( GameObject helperIcon, CatMachineControllerArcade catMachineController, int indexBar )
	{
		this.helperIcon = helperIcon;
		cMCArcade 		= catMachineController;
		this.indexBar  	= indexBar;
	}
	
	void Update()
	{
		if( firstTime )
		{
			firstTime = false;
		}
		Dragging();
	}
	
	
	void LateUpdate()
	{


		transform.localPosition = new Vector3( transform.localPosition.x, transform.localPosition.y, -2  );
		
		//Si esta en pausa
		//o
		//si esta en modo campaign y el gato esta dentro del tubo no se debe poder coger.
		//o
		//Si ha usado el powerup del ninja, no puede usar los gatos.
		if( Time.timeScale <= 0 || isInTube || GameManager.Instance.SetupInitLevel.tutorialMode || PowerUpNinja.powerUpNinjaActived )
		{
			dragItemScript.enabled = false;
			collider.enabled		= false;


		}
		else
		{
			dragItemScript.enabled = true;
			collider.enabled		= true;

		}

		if( !isInTube )
		{
			typeCatOnMachine = currentTypeCat;
		}

		//Si esta en modo tutorial y no esta en el tubo
		if( GameManager.Instance.SetupInitLevel.tutorialMode && !isInTube )
		{
			TutorialManager.instance.SetCurrentDroppableCat( this );
		}
		
	}
	
	private void Dragging()
	{
		if( GameManager.Instance.GameStats.EndLevel )
		{
			helperIcon.SetActive(false);
			gameObject.SetActive(false);
		}
		if( mIsDragging )
		{

			target.localScale 	= new Vector3(1,1,1);
			
			if( GameManager.Instance.SetupInitLevel.tutorialMode )
			{
				transform.position = TutorialManager.instance.tutorialHand.transform.position;

				target.position = ClampPosition();
				helperIcon.transform.position = transform.position;
				
				currentPosition = target.position;
			}
			else
			{
				if( dragItemScript.isBtnActive )
				{
					greenFloor.SetActive(true);
					
					
					target.position = ClampPosition();
					
					
					helperIcon.transform.position = transform.position;

					currentPosition = target.position;

					
				}
				else
				{
					OnUp();
				}
			}
		}
	}
	
	
	/// <summary>
	/// Drop the dragged object.
	/// </summary>

	private void OnUp()
	{
		if( GetComponent<CatSkinController>() != null )
		{
			GetComponent<CatSkinController>().CheckEnabledSkins();
		}
		OnUpCat();
	}
	
	public Vector3 ClampPosition()
	{
		
		Vector3  positionScreen = GUICamera.instanceCamera.camera.WorldToScreenPoint(transform.position);
			
		Vector3 adjustedPos = Vector3.zero;
		adjustedPos.z = transform.position.z;
		
		//Calculamos posicion X
		if( Camera.main.ScreenToWorldPoint(positionScreen).x < CameraController.minX + 15)
		{
			Vector3 vectorAux = Camera.main.WorldToScreenPoint( Vector3.right*(CameraController.minX) );
			adjustedPos.x = GUICamera.instanceCamera.camera.ScreenToWorldPoint(vectorAux).x + 15;
			
		}
		else if( CameraController.maxX - 15 < Camera.main.ScreenToWorldPoint(positionScreen).x )
		{
			Vector3 vectorAux = Camera.main.WorldToScreenPoint( Vector3.right*CameraController.maxX );
			adjustedPos.x = GUICamera.instanceCamera.camera.ScreenToWorldPoint(vectorAux).x - 15;
			
		}
		else
		{
			adjustedPos.x = transform.position.x;
		}
		//208.5
		//Calculamos posicion Y
		//Vector3 t = positionScreen - Vector3.forward*120;
		if( Camera.main.ScreenToWorldPoint( positionScreen ).y < greenFloor.transform.position.y + 20 )
		{
			Vector3 vectorAux = Camera.main.WorldToScreenPoint(greenFloor.transform.position);
			adjustedPos.y = GUICamera.instanceCamera.camera.ScreenToWorldPoint(vectorAux).y + 20;
			
		}
		else if( (heightFloor + greenFloor.transform.position.y + 10) < Camera.main.ScreenToWorldPoint(positionScreen).y )
		{
			Vector3 vectorAux = Camera.main.WorldToScreenPoint(Vector3.up*(heightFloor + greenFloor.transform.position.y));
			adjustedPos.y = GUICamera.instanceCamera.camera.ScreenToWorldPoint(vectorAux).y + 10;
			
		}
		else
		{
			adjustedPos.y = transform.position.y;
		}
				
		return adjustedPos;
	}
	
	public void OnUpCat()
	{
		greenFloor.SetActive(false);
		helperIcon.SetActive(false);
		
		IS_DRAGGING = false;
		mIsDragging = false;
		
		
		
		
		//Vector3  positionScreen = GUICamera.instanceCamera.camera.WorldToScreenPoint(transform.position);
		/*Vector3  positionScreen = GUICamera.instanceCamera.camera.WorldToScreenPoint( target.position );
		Vector3 positionSpawnCat = Camera.main.ScreenToWorldPoint(positionScreen);
		Vector3 targetPositionAux = Camera.main.ScreenToWorldPoint(positionScreen);
			
		
		if( (heightFloor + 25) > Camera.main.ScreenToWorldPoint(positionScreen).y 
			&& Camera.main.ScreenToWorldPoint(positionScreen).x > CameraController.minScreenX
			&& CameraController.maxScreenX > Camera.main.ScreenToWorldPoint(positionScreen).x)
		*/
		
		Vector3  positionScreen = GUICamera.instanceCamera.camera.WorldToScreenPoint( target.position );
		Vector3 positionSpawnCat = Camera.main.ScreenToWorldPoint(positionScreen);
		Vector3 targetPositionAux = Camera.main.ScreenToWorldPoint(positionScreen);
			
		
		//positionSpawnCat.y = initialPos.y + 40;
		positionSpawnCat.y = Camera.main.transform.position.y + Camera.main.GetComponent<tk2dCamera>().ScreenExtents.height/2 + 40;
		
		GameObject cat = (GameObject)Instantiate( prefab, positionSpawnCat, Quaternion.identity );
		cat.transform.position = new Vector3( cat.transform.position.x, cat.transform.position.y, -9 );
		
		cat.GetComponent<CatController>().targetPosition =  targetPositionAux - Vector3.up*10;
		cat.GetComponent<CatController>().dir	= Random.Range(0,2);
		if( cat.GetComponent<CatController>().dir == 0 )
		{
			cat.GetComponent<CatController>().dir = -1;
		}
			
		
		if( cMCCampaign != null )
		{
			cMCCampaign.MoveNextCat();
		}
		else
		{
			cMCArcade.UpdateCatCount(indexBar);
		}
		
		//PROVISIONAL!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!///////////////////
		if( cMCArcade != null )
		{
			if(int.Parse(cMCArcade.textCountCatList[indexBar].text) <= 0)
			{
				gameObject.SetActive(false);
			}
		}
		else
		{
			Destroy( gameObject );
		}
			
		
		target.parent = transform;
		target.localPosition = Vector3.zero;
	}
	
	/// <summary>
	/// Cache the transform.
	/// </summary>

	//void Awake () { mTrans = transform; }

	/// <summary>
	/// Start the drag event and perform the dragging.
	/// </summary>
	/*
	void OnDrag (Vector2 delta)
	{
	}*/

	/// <summary>
	/// Start or stop the drag operation.
	/// </summary>

	public void OnDown()
	{
		if( !GameManager.Instance.GameStats.EndLevel && Time.timeScale >= 1 )
		{
			if( !GameManager.Instance.SetupInitLevel.tutorialMode )
			{
				//Poner a true esta variable para que sepa que el gato se ha movido y no necesita usar el helper de la mano IPD
				HelperHandAfk.catMoved = true;
			}
			initialPosition = transform.position;
			
			mIsDragging = true;
			IS_DRAGGING = true;
			helperIcon.SetActive(true);
			
			//target.parent = null;

		

			if( 3 < helperIcon.transform.childCount )
			{
				helperIcon.transform.GetChild(3).GetComponent< DragCatIconArrow >().currentDroppableCat = target;
			}
			
			//helperCircle.SetActive(true);
		}
	}

	//Metdo usado para resetar cuando es usado en modo tutorial
	public void Reset()
	{
		if( !GameManager.Instance.GameStats.EndLevel && Time.timeScale >= 1 )
		{
			//initialPosition = transform.position;
			
			mIsDragging = false;
			IS_DRAGGING = false;
			helperIcon.SetActive(false);
			
			target.parent = transform;
			transform.localPosition = Vector3.zero;

			/*
			if( 3 < helperIcon.transform.childCount )
			{
				helperIcon.transform.GetChild(3).GetComponent< DragCatIconArrow >().currentDroppableCat = target;
			}*/

			greenFloor.SetActive(false);
			

			//helperCircle.SetActive(true);
		}
	}
	
	public void ReturnInitialState()
	{
		transform.position = initialPosition;
		helperIcon.transform.position = initialPosition;
		IS_DRAGGING = false;
		helperIcon.SetActive( false );
		
		/*Destroy(gameObject);*/
	}
	 
	protected void Infect( SimController sim, GameObject cat )
	{
		sim.gameObject.GetComponent<CatAttacher>().AttachCat( cat );
		cat.GetComponent<CatController>().InfectSim();
		// = true;
		sim.InfectedSimByCat( cat.GetComponent<CatController>().instantZombie );

	}
	
	IEnumerator TimerActive()
	{
		yield return new WaitForSeconds(0.8f);
		collider.enabled = true;
	}
}
