using UnityEngine;
using System.Collections;

public class Coin : MonoBehaviour {
	
	private bool onPickUP = false;
	
	private Vector3 positionCoinGUI;
	private Vector3 positionCoinGUIAux;
	
	private float speedPickUp 	= 3f;
	private float timeDead 		= 0.5f;
	
	private float distanceAB 	= 0;
	
	private float contSpeed 	= 0; 
	
	private bool picked			= false;
	
	private bool dead 			= false;
	
	public Vector3 currentSpeed;
	public float initialY;
	
	public GameObject shinyEffectPrefab01;
	public GameObject shinyEffectPrefab02;
	
	public bool coinFromLastSim = false;
	
	public int directionSpawn = 0;
	
	private bool secondPhase = false;
	
	private int indexState = 0;

	private float creationTime;

	// Use this for initialization
	void Start () {
		int xRand 	= Random.Range(1,5)*25*directionSpawn;
		/*int dir  	= Random.Range(0,2);
		if(dir == 0)
		{
			dir = -1;
		}*/
		int yRand 	= Random.Range(1,5)*10;
		currentSpeed = new Vector3(xRand,550+yRand,0);
		
		initialY = transform.position.y;
		initialY += Random.Range(2,8)*5;
		
		CoinGUI.AddCoin( transform );

		creationTime = Time.time;
	}
	

	
	// Update is called once per frame
	void Update ()
	{
		if( GameManager.Instance.GameStats.EndLevel && Time.time - creationTime < 2f  )
		{
			CoinGUI.RemoveCoin( transform );
			
			GameManager.Instance.GameStats.LevelCoins++;
			
			SpawnShinyEffect();
			
			Destroy(gameObject);
		}
		if( coinFromLastSim )
		{
			picked = true;
			PickUp();
			
			coinFromLastSim = false;
			
		}

		if( onPickUP )
		{
			//set position coinGUI
			//Vector3  positionScreen = GUICamera.instanceCamera.camera.WorldToScreenPoint(CoinGUI.instance.position);
			//positionCoinGUI = Camera.main.ScreenToWorldPoint(positionScreen);
			
			contSpeed += 0.001f;
			float x =  Mathf.Lerp(transform.position.x,positionCoinGUI.x, Time.deltaTime*speedPickUp+contSpeed);
			float y =  Mathf.Lerp(transform.position.y,positionCoinGUI.y, Time.deltaTime*speedPickUp+contSpeed);
			
			transform.position = new Vector3(x,y,transform.position.z);
			
			//transform.position = transform.position + Vector3.Normalize(positionCoinGUI-transform.position)*distanceAB/2*Time.deltaTime*speedPickUp;
			
			//transform.position Vector3.Normalize(positionCoinGUI)*Time.deltaTime );
			
			transform.RotateAround (positionCoinGUI, Vector3.back, 100 * Time.deltaTime + contSpeed*150);
		
			if( Vector3.Distance( transform.position, positionCoinGUI ) < 20 )
			{
				if(!dead)
				{
					StartCoroutine( TimerDestroy() );
				}
			}
		}
		else
		{
			switch( indexState )
			{
				case 0:
					if( !(transform.position.y <= initialY && currentSpeed.y < 0) )
					{
						transform.position 	+= currentSpeed * Time.deltaTime;
						currentSpeed 		+= Vector3.down*10;
					}
					else
					{
						currentSpeed.y = 250;
						indexState++;
					}
					break;
				case 1:
					if( !(transform.position.y <= initialY && currentSpeed.y < 0) )
					{
						transform.position 	+= currentSpeed * Time.deltaTime;
						currentSpeed 		+= Vector3.down*10;
					}
					else
					{
						indexState++;
						CoinGUI.RemoveCoin( transform );
						StartCoroutine( TimerBrokeDestroy() );
						
						SpawnBrokenEffect();
					
					}
					break;
				case 2:
				/*
					if( transform.localScale.x < 0.1f )
					{
						SpawnBrokenEffect();
						Destroy( gameObject );
					}*/
					//transform.localScale -= new Vector3( 0.1f, 0.1f, 0.1f );
					break;
			}
		}
	}
	
	void LateUpdate()
	{
		if( onPickUP )
		{
			transform.position = new Vector3(transform.position.x, transform.position.y, -6.5f+positionCoinGUI.z);
		}
		else
		{
			//ControlZ();
		}

	}

	void ControlZ()
	{
		float auxUL = GameManager.Instance.SimSetupSettings.ListFloorLimit[0,1];
		float auxDistance = auxUL - initialY;
		float auxZ = GameManager.Instance.SimSetupSettings.FarZSim - auxDistance;
		auxZ = Mathf.Clamp(auxZ,GameManager.Instance.SimSetupSettings.FarZ - GameManager.Instance.SimSetupSettings.WidthFloor, GameManager.Instance.SimSetupSettings.FarZ);
		this.transform.position = new Vector3(this.transform.position.x,
		                                      this.transform.position.y,
		                                      auxZ);
	}
	
	public void OnClick()
	{
		if( !picked && 0 < Time.timeScale && !GameManager.Instance.GameStats.EndLevel )
		{
			picked = true;
			PickUp();
		}
	}
	
	void PickUp()
	{
		onPickUP = true;
		transform.localScale *= (CameraController.cameraScript.ZoomFactor);
		transform.parent = CoinGUI.instance;
		positionCoinGUI = CoinGUI.instance.position;
		
		
		
		
		distanceAB = Vector3.Distance(positionCoinGUI,transform.position);
		
		Vector3  positionScreen = Camera.main.camera.WorldToScreenPoint(transform.position);
		transform.position = GUICamera.instanceCamera.ScreenToWorldPoint(positionScreen);
		
		
		gameObject.layer = LayerMask.NameToLayer("GUI");
		transform.GetChild(0).gameObject.layer = LayerMask.NameToLayer("GUI");
	}
	
	IEnumerator TimerDestroy()
	{
		dead = true;
		
		
		yield return new WaitForSeconds(timeDead);
		GameManager.Instance.GameStats.LevelCoins++;

		SpawnShinyEffect();
		
		Destroy(gameObject);
	}
	IEnumerator TimerBrokeDestroy()
	{
		transform.GetChild(0).GetComponent<tk2dSpriteAnimator>().Play("broke");
		yield return new WaitForSeconds(0.25f);
		
		Destroy(gameObject);
	}
	void SpawnBrokenEffect()
	{
		GameObject shinyEffectAux;
		for(int i=0;i<6;i++)
		{
			shinyEffectAux = (GameObject)GameObject.Instantiate( shinyEffectPrefab02,
																//transform.position+Vector3.forward*-92, 
																transform.position, 
																Quaternion.AngleAxis( Random.Range(0,359),Vector3.forward ) );
			shinyEffectAux.layer = LayerMask.NameToLayer("Default");
			shinyEffectAux.transform.parent = transform.parent;
			
		}
	}
	void SpawnShinyEffect()
	{
		GameObject shinyEffectAux;
		for(int i=0;i<6;i++)
		{
			shinyEffectAux = (GameObject)GameObject.Instantiate( shinyEffectPrefab01,
																//transform.position+Vector3.forward*-92, 
																transform.position, 
																Quaternion.AngleAxis( Random.Range(0,359),Vector3.forward ) );
			shinyEffectAux.transform.parent = transform.parent;
			shinyEffectAux.transform.position = new Vector3(shinyEffectAux.transform.position.x,shinyEffectAux.transform.position.y,-297);
			
		}
	}
	
	void OnDrawGizmos()
	{
		Gizmos.color = Color.yellow;
		Gizmos.DrawWireSphere(transform.position, 75);
	}
}
