﻿using UnityEngine;
using System.Collections;

public class HelperCircle : MonoBehaviour {
	
	protected tk2dSprite sprite;
	protected tk2dSprite spriteChild;
	
	public float delayOff = 2;
	
	public float maxAlpha = 0.75f;
	
	protected int dirAlpha = -1;
	protected float currentAlpha;
	
	protected bool wait = false;
	protected bool activeCircle = false;

	
	// Use this for initialization
	void Awake ()
	{
		Initialize();

		currentAlpha = maxAlpha;
	}

	protected void Initialize()
	{
		sprite 		= GetComponent<tk2dSprite>();
		spriteChild = transform.GetChild(0).GetComponent<tk2dSprite>();
		sprite.color 	= new Color(sprite.color.r, sprite.color.g, sprite.color.b, maxAlpha);
	}
	// Update is called once per frame
	void Update ()
	{
		
		if( !wait )
		{
			if( currentAlpha < 0 || maxAlpha < currentAlpha )
			{
				if( currentAlpha < 0 )
				{
					wait =  true;
					StartCoroutine(TimerDelayAlpha());
					currentAlpha = 0;
				}
				else if( maxAlpha < currentAlpha )
				{
					currentAlpha = maxAlpha;
				}
				dirAlpha *= -1;
			}
			ChangeAlpha();
			currentAlpha += dirAlpha*Time.deltaTime;
			
		}
		
	}
	
	void LateUpdate()
	{
		transform.position = new Vector3( transform.position.x, transform.position.y, -250 );
	}
	
	void ChangeAlpha()
	{
		sprite.color 		= new Color(sprite.color.r, sprite.color.g, sprite.color.b, currentAlpha);
		spriteChild.color 	= new Color(spriteChild.color.r, spriteChild.color.g, spriteChild.color.b, currentAlpha);
	}
	

	
	IEnumerator TimerDelayAlpha()
	{
		yield return new WaitForSeconds( delayOff  );
		wait = false;
	}
}
