﻿using UnityEngine;
using System.Collections;

public class ManageLevelSelect : MonoBehaviour {
	
	
	public GameObject PreApocalypseLevels;
	public GameObject ApocalypseLevels;
	public GameObject PostApocalypseLevels;
	
	public GameObject ButtonNextLevels;
	public GameObject ButtonBackLevels;
	
	public tk2dTextMesh Title;
	
	private static int currentGroupLevels;
	
	// Use this for initialization
	void Start () 
	{
		ManageLevelSelect.currentGroupLevels = 0;
		this.setupLevels();
	}
	
	// Update is called once per frame
	void Update () 
	{
	
	}
	
	public void ChangeLevels(int increase)
	{
		if (increase > 0)
		{
			if ((ManageLevelSelect.currentGroupLevels + 1) < 3)
			{
				ManageLevelSelect.currentGroupLevels++;	
			}else
			{
				ManageLevelSelect.currentGroupLevels = 2;	
			}
		}else
		{
			if ((ManageLevelSelect.currentGroupLevels - 1) >= 0)
			{
				ManageLevelSelect.currentGroupLevels --;	
			}else
			{
				ManageLevelSelect.currentGroupLevels = 0;	
			}
		}
		this.setupLevels();
		
		
		
	}
	
	private void setupLevels()
	{
		string auxTitle = "";
		this.ButtonNextLevels.SetActive(true);
		this.ButtonBackLevels.SetActive(true);
		switch(ManageLevelSelect.currentGroupLevels)
		{
			case 0:
				this.PreApocalypseLevels.SetActive(true);
				this.ApocalypseLevels.SetActive(false);
				this.PostApocalypseLevels.SetActive(false);
			
				auxTitle = "Level Select Pre-Apocalypse";
				this.ButtonBackLevels.SetActive(false);
			
			
			break;
			case 1:	
				this.PreApocalypseLevels.SetActive(false);
				this.ApocalypseLevels.SetActive(true);
				this.PostApocalypseLevels.SetActive(false);
				auxTitle = "Level Select Apocalypse";
			
			
			break;
			case 2:	
				this.PreApocalypseLevels.SetActive(false);
				this.ApocalypseLevels.SetActive(false);
				this.PostApocalypseLevels.SetActive(true);
				auxTitle = "Level Select Post Apocalypse";
				this.ButtonNextLevels.SetActive(false);
			
			break;
		}
		
		this.Title.text = auxTitle;
		this.Title.Commit();
		
	}
}
