﻿using UnityEngine;
using System.Collections;

public class PowerupPanelController : MonoBehaviour {

	public GameObject powerupPanel;
	

	public GameObject buttonNinja;
	private tk2dSlicedSprite spriteButton;

	public tk2dTextMesh currentCoinsText;

	private int totalCoins = 0;

	public static PowerupPanelController Instance;

	[System.NonSerialized]
	public bool powerUpDisabled = false;

	void Awake()
	{
		if( Instance == null )
		{
			Instance = this;
		}
	}

	// Use this for initialization
	void Start () {

		//PlayerPrefs.SetInt("TotalCoins",601);

		spriteButton = buttonNinja.transform.GetChild(0).GetComponent<tk2dSlicedSprite>();

		totalCoins = PlayerPrefsManager.GetTotalCoins();
		currentCoinsText.text = "" + totalCoins;

		if( totalCoins < 200 )
		{
			spriteButton.SetSprite( "buttonDisabled_PU_nin" );
			buttonNinja.collider.enabled = false;
		}
	}
	
	// Update is called once per frame
	void Update () {
		if(powerUpDisabled)
		{
			powerupPanel.SetActive(false);
		}

	}

	public void DisablePanel()
	{
		powerUpDisabled = true;
	}
}
