﻿using UnityEngine;
using System.Collections;

public class SkinButton : MonoBehaviour {


	public int index = 0;
	public SkinPanelController skinPanel;

	public float minX = -2.75f;
	public float maxX = 27;

	private int dir = 1;
	private float speed = 100;

	private Transform transform;

	private bool activedSkin = false;

	// Use this for initialization
	void Start () {
		transform = GetComponent<Transform>();

		if( index == PlayerPrefsManager.GetSkinActive("baseCat") )
		{
			activedSkin = true;
			dir			= -1;
		}
		else
		{
			activedSkin = false;
			dir			= 1;
		}
		SetActivationState(activedSkin);

		switch( index )
		{
			//Si es 0 significa que es el boton del gato comun, necesita que al menos blackCat este desactivado para salir.
		case 0:
			if( 0 < PlayerPrefsManager.IsSkinUnlock( CatSkinController.SkinType.BLACK_CAT ) )
			{
				gameObject.SetActive(true);
			}
			else
			{
				gameObject.SetActive(false);
			}
			break;
		case 1:
			if( 0 < PlayerPrefsManager.IsSkinUnlock( CatSkinController.SkinType.BLACK_CAT ) )
			{
				gameObject.SetActive(true);
			}
			else
			{
				gameObject.SetActive(false);
			}
			break;
		case 2:
			if( 0 < PlayerPrefsManager.IsSkinUnlock( CatSkinController.SkinType.MAGIC_CAT ) )
			{
				gameObject.SetActive(true);
			}
			else
			{
				gameObject.SetActive(false);
			}
			break;
		case 3:
			if( 0 < PlayerPrefsManager.IsSkinUnlock( CatSkinController.SkinType.BAT_CAT ) )
			{
				gameObject.SetActive(true);
			}
			else
			{
				gameObject.SetActive(false);
			}
			break;
		}
		
	}
	
	// Update is called once per frame
	void Update () {
		if( dir < 0 && minX < transform.localPosition.x || 0 < dir && transform.localPosition.x < maxX )
		{
			transform.position += Vector3.right * dir * speed * Time.unscaledDeltaTime;
		}
	}



	public void OnSkinButtonClick()
	{
		skinPanel.UpdateSkinButton( index );
	}

	public void SetActivationState( bool activation )
	{
		activedSkin = activation;
		if( activedSkin )
		{
			dir = -1;
		}
		else
		{
			dir = 1;
		}
	}
}
