﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public class Starbar : MonoBehaviour {
	
	public GameObject starBar;
	
	private SkeletonAnimation starBarAnimation;
	
	//0 none 1 bronze 2 silver 3 gold
	public enum stateStarbar
	{
		none,
		bronze,
		silver,
		gold,
	}
	private stateStarbar currentStateStarbar;
	private int lastNumberInfected = 0;
	
	//private List<string> listAnimationToDo;
	//private bool waitAnimation = false;
	// Use this for initialization
	void Start ()
	{
		starBar.transform.position += Vector3.right*1.5f;
		
		starBarAnimation = starBar.GetComponent<SkeletonAnimation>();
		
		//listAnimationToDo = new List<string>();
	}
	
	// Update is called once per frame
	void Update ()
	{
		switch( currentStateStarbar )
		{
			case stateStarbar.none:
				if( GameManager.Instance.SetupInitLevel.NumberGoldInfected <= GameManager.Instance.NumberInfected )
				{
					//special de nada a oro
					PlayAnimation("noneToGoldAnim");
					currentStateStarbar = stateStarbar.gold;
				}
				else if( GameManager.Instance.SetupInitLevel.NumberSilverInfected <= GameManager.Instance.NumberInfected )
				{
					//special de nada a silver
					PlayAnimation("noneToSilverAnim");
					currentStateStarbar = stateStarbar.silver;
				
				}
				else if( GameManager.Instance.SetupInitLevel.NumberBronzeInfected <= GameManager.Instance.NumberInfected )
				{
					PlayAnimation("bronzeAnim");
					currentStateStarbar = stateStarbar.bronze;
				
				}
				break;
			case stateStarbar.bronze:
				if( GameManager.Instance.SetupInitLevel.NumberGoldInfected <= GameManager.Instance.NumberInfected )
				{
					//special de bronze a gold
					PlayAnimation("bronzeToGoldAnim");
					currentStateStarbar = stateStarbar.gold;
				}
				else if( GameManager.Instance.SetupInitLevel.NumberSilverInfected <= GameManager.Instance.NumberInfected )
				{
					PlayAnimation("silverAnim");
					currentStateStarbar = stateStarbar.silver;
				}
				if( GameManager.Instance.NumberInfected < lastNumberInfected )
				{
					if( GameManager.Instance.NumberInfected < GameManager.Instance.SetupInitLevel.NumberBronzeInfected )
					{
						PlayAnimation("bronzeToNoneAnim");
					currentStateStarbar = stateStarbar.none;
					}
				}
				break;
			case stateStarbar.silver:
				if( GameManager.Instance.SetupInitLevel.NumberGoldInfected <= GameManager.Instance.NumberInfected )
				{
					PlayAnimation("goldAnim");
					currentStateStarbar = stateStarbar.gold;
				}
				if( GameManager.Instance.NumberInfected < lastNumberInfected )
				{
					if( GameManager.Instance.NumberInfected < GameManager.Instance.SetupInitLevel.NumberBronzeInfected )
					{
						//special de silver a nada
						PlayAnimation("silverToNoneAnim");
					currentStateStarbar = stateStarbar.none;
					}
					else if( GameManager.Instance.NumberInfected < GameManager.Instance.SetupInitLevel.NumberSilverInfected )
					{
						PlayAnimation("silverToBronzeAnim");
					currentStateStarbar = stateStarbar.bronze;
					}
				}
				break;
			case stateStarbar.gold:
				break;
		}
		
		lastNumberInfected = GameManager.Instance.NumberInfected;
		
		/*
		if( 0 < GameManager.Instance.NumberInfected )
		{
			if( GameManager.Instance.SetupInitLevel.NumberBronzeInfected <= GameManager.Instance.NumberInfected )
			{
				PlayAnimation("bronzeAnim");
			}
			else if( GameManager.Instance.SetupInitLevel.NumberSilverInfected <= GameManager.Instance.NumberInfected )
			{
				PlayAnimation("silverAnim");
			}
			else if( GameManager.Instance.SetupInitLevel.NumberGoldInfected <= GameManager.Instance.NumberInfected )
			{
				PlayAnimation("goldAnim");
			}
		}
		if( GameManager.Instance.NumberInfected < lastNumberInfected )
		{
			if( starBarAnimation.animationName == "silverAnim" )
			{
				if( GameManager.Instance.NumberInfected < GameManager.Instance.SetupInitLevel.NumberSilverInfected )
				{
					PlayAnimation("silverAnimReverse");
				}
				else 	if( GameManager.Instance.NumberInfected < GameManager.Instance.SetupInitLevel.NumberBronzeInfected )
				{
					PlayAnimation("bronzeAnimReverse");
				}
			}
			else if( starBarAnimation.animationName == "bronzeAnim" )
			{
				if( GameManager.Instance.NumberInfected < GameManager.Instance.SetupInitLevel.NumberBronzeInfected )
				{
					PlayAnimation("bronzeAnimReverse");
				}
				else if( GameManager.Instance.NumberInfected < GameManager.Instance.SetupInitLevel.NumberSilverInfected )
				{
					PlayAnimation("silverAnimReverse");
				}
			}
		}
		
		
		
		if( !waitAnimation && 0 < listAnimationToDo.Count)
		{
			PlayAnimation( listAnimationToDo[listAnimationToDo.Count-1] );
			listAnimationToDo.RemoveAt( listAnimationToDo.Count-1 );
		}*/
	}
	
	
	void PlayAnimation( string animationName )
	{
		starBarAnimation.animationName = animationName;
		/*
		if( starBarAnimation.animationName != animationName )
		{
			if( !waitAnimation )
			{
				starBarAnimation.animationName = animationName;
				StartCoroutine( TimerWait() );
			}
			else
			{
				listAnimationToDo.Add( animationName );
			}
		}*/
		
	}
	/*
	IEnumerator TimerWait()
	{
		waitAnimation = true;
		yield return new WaitForSeconds(1.1f);
		waitAnimation = false;
		
	}
	*/
	
	
}


