using UnityEngine;
using System.Collections;

public class SelectLevelFrameController : MonoBehaviour {
	
	public GameObject buttonsGroup;
	
	public FrameController[] frames;
	
	public ButtonLevel[] levelButtons;
	//public int[] indicesFramesScreen = new int[]{-2,-1,0,1,2};
	
	public BoxCollider selectWorldCollider;
	
	/*private Vector3 position0 = new Vector3(0,-28,0);
	private Vector3 pos1_right = new Vector3(283,35,1);
	private Vector3 pos2_right = new Vector3(516,87,2);
	private Vector3 pos1_left = new Vector3(283,35,1);
	private Vector3 pos2_left = new Vector3(516,87,2);
	
	private Vector3 size0 = new Vector3(1,1,1);
	private Vector3 size1 = new Vector3(0.8f,0.8f,1);
	private Vector3 size2 = new Vector3(0.6f,0.6f,1);*/
	
	private bool firstTime = true;
	
	
	//public int IndexWorldSelect = 0;
	// Index for middle position 
	public int IndexScreenPosMiddle = 3;
	
	public int LastWorldSelected = 0;

	public bool canChangeWorld = true;


	void Awake()
	{
		//PlayerPrefs.DeleteAll();
		/*
		PlayerPrefs.SetInt( GameSettings.NamePrefTotalStars, 80 );
		for(int i = 0;i<22;i++)
		{
			PlayerPrefsManager.AddWinLevel("" + 2 + "_" + i + "_level");
			
		}*/

	}
	// Use this for initialization
	void Start () 
	{
		firstTime = true;
		LastWorldSelected = PlayerPrefsManager.SetPlayerPrefs(PlayerPrefsManager.TypeAction.LOAD_ACTION,PlayerPrefsManager.TypePrefs.LASTSELECTEDWORLD_PREF);
		GameSettings.SetSoundEffecttk2d();
	}
	
	// Update is called once per frame
	void Update () {
		if( firstTime )
		{
			OnClickRight();
			firstTime = false;
		}
	}
	
	void OnClickRight()
	{
		if( canChangeWorld )
		{
			StartCoroutine( TimerDelayChangeWorld() );
			if (frames[0].positionScreen < 3)
			{
				for( int i = 0; i < frames.Length; i++ )
				{
					/*indicesFramesScreen[i]++;
					if( 0 <= indicesFramesScreen[i] && indicesFramesScreen[i] < 5 )
					{
						frames[i]
					}*/
					frames[i].PlayAnimation(true);
				}
			}
		}

		CheckCurrentLevelLock();
	}
	
	void OnClickLeft()
	{
		if( canChangeWorld )
		{
			StartCoroutine( TimerDelayChangeWorld() );
			if( 3 < frames[frames.Length-1].positionScreen)
			{
				for( int i = 0; i < frames.Length; i++ )
				{
					/*indicesFramesScreen[i]++;
					if( 0 <= indicesFramesScreen[i] && indicesFramesScreen[i] < 5 )
					{
						frames[i]
					}*/
					frames[i].PlayAnimation(false);
				}
			}
		}

		CheckCurrentLevelLock();
	}

	void CheckCurrentLevelLock()
	{
		int auxIndexWorldSelected = 0;
		for( int i = 0; i < frames.Length; i++ )
		{
			if (frames[i].positionScreen == this.IndexScreenPosMiddle)
			{
				
				auxIndexWorldSelected = frames[i].IndexWorld;
				break;
			}
		}

		selectWorldCollider.enabled = !frames[auxIndexWorldSelected].isLock;
	}

	void OnSelectWorld()
	{
		int auxIndexWorldSelected = 0;
		for( int i = 0; i < frames.Length; i++ )
		{
			if (frames[i].positionScreen == this.IndexScreenPosMiddle)
			{
				
				auxIndexWorldSelected = frames[i].IndexWorld;
				break;
			}
		}

		// Check if number of worlds is less than number of worlds
		if (auxIndexWorldSelected < GameSettings.NumberWorlds)
		{
			buttonsGroup.animation.Play("levelSelection");

			bool allbuttonsEnabled = false;
			if( PlayerPrefsManager.IsLevelWon("" + auxIndexWorldSelected + "_" + "13" + "_level") )
			{
				allbuttonsEnabled = true;
			}

			bool lockLevels = false;
			for (int i = 0; i < levelButtons.Length; i++)
			{
				if( !allbuttonsEnabled )
				{
					if( lockLevels )
					{
						levelButtons[i].LockButton();
					}
					else
					{
						levelButtons[i].UnlockButton();
						
						if( i <= 13 && !PlayerPrefsManager.IsLevelWon("" + auxIndexWorldSelected + "_" + i + "_level") )
						{
							lockLevels = true;
						}
					}
				}
				else
				{
					levelButtons[i].UnlockButton();
				}

				//levelButtons[i].ind
				levelButtons[i].IndexSelectWorld = auxIndexWorldSelected;


				// Get stars level
				PlayerPrefsManager.LevelStat auxL = PlayerPrefsManager.GetLevel(auxIndexWorldSelected,i);
				Debug.Log(" AUXL " + auxL.Stars);
				switch(auxL.Stars)
				{
				case 0:
					levelButtons[i].bronceStar.SetActive(false);
					levelButtons[i].silverStars.SetActive(false);
					levelButtons[i].goldStars.SetActive(false);
					break;
				case 1:
					levelButtons[i].bronceStar.SetActive(true);
					levelButtons[i].silverStars.SetActive(false);
					levelButtons[i].goldStars.SetActive(false);
					break;
				case 2:
					levelButtons[i].bronceStar.SetActive(false);
					levelButtons[i].silverStars.SetActive(true);
					levelButtons[i].goldStars.SetActive(false);
					break;
				case 3:
					levelButtons[i].bronceStar.SetActive(false);
					levelButtons[i].silverStars.SetActive(false);
					levelButtons[i].goldStars.SetActive(true);
					break;

				}
				levelButtons[i].levelStars.animation.Play("starsLevelHidden");	
				//levelButtons[i].levelStars.animation.Play("starsLevel");	
			}
			
			StartCoroutine(TimerPlayAnimationLevelSelection());
		
		}
			
	}
	
	void OnBackWorldSelection()
	{
		buttonsGroup.animation.Play("worldSelection");
		/*for (int i = 0; i < levelButtons.Length; i++)
		{
			levelButtons[i].levelStars.animation["starsLevel"].speed = -1;
			levelButtons[i].levelStars.animation["starsLevel"].time = levelButtons[i].levelStars.animation["starsLevel"].length;
			levelButtons[i].levelStars.animation.Play("starsLevel");	
		}*/
	}
	
	IEnumerator TimerDelayChangeWorld()
	{
		canChangeWorld = false;
		yield return new WaitForSeconds( 0.25f );
		canChangeWorld = true;
	}
	
	IEnumerator TimerPlayAnimationLevelSelection()
	{
		yield return new WaitForSeconds( buttonsGroup.animation["worldSelection"].time + 0.45f );
		for (int i = 0; i < levelButtons.Length; i++)
		{
			//levelButtons[i].levelStars.animation["starsLevel"].speed = 1;
			//levelButtons[i].levelStars.animation["starsLevel"].time = 0;
			Debug.Log(" STAR ANIMATION");
			levelButtons[i].levelStars.animation.Play("starsLevel");	
		}
	}
}
