using UnityEngine;
using System.Collections;

public class HelperHandAfk : MonoBehaviour {

	public float firstTimeShowHand 	= 3;
	public float timeShowHand	 	= 5;

	private bool faceOut			= false;

	private tk2dSprite sprite;

	public float speedFaceOut		= 1.25f;
	public float timeFaceOut		= 2.75f;

	public static bool catMoved		= false;

    public GameObject arrowHelper;

	private MeshRenderer meshRenderer;

	void OnEnable()
	{
		catMoved = false;
		faceOut = false;
	}

	// Use this for initialization
	void Start ()
	{
		sprite 			= GetComponent<tk2dSprite>();
		meshRenderer	= GetComponent<MeshRenderer>();

		StartCoroutine( TimeToShow(firstTimeShowHand) );
	}
	
	// Update is called once per frame
	void Update () {
		//Si esta en pause que siempre se ponga el render a falso
		if( Time.timeScale == 0 || GameManager.Instance.GameStats.EndLevel )
		{
			meshRenderer.enabled = false;
            arrowHelper.SetActive(false);
		}
		if( faceOut )
		{
			sprite.color = new Color( sprite.color.r, sprite.color.g, sprite.color.b, sprite.color.a - Time.deltaTime*speedFaceOut );

			if( sprite.color.a <= 0 )
			{
				faceOut = false;
				sprite.color = new Color(1,1,1,1);
				meshRenderer.enabled = false;
                arrowHelper.SetActive(false);

				StartCoroutine( TimeToShow(timeShowHand) );
			}
		}
	}
	
	IEnumerator TimeToShow( float time )
	{
		
		yield return new WaitForSeconds( time );
		if( !catMoved )
		{
			//si no esta en pause
			if( 0 < Time.timeScale )
			{
				//Si esta en tutorial nunca mostrara el renderer
				if( !GameManager.Instance.SetupInitLevel.tutorialMode && 0 < Time.time )
				{
					meshRenderer.enabled = true;
                    arrowHelper.SetActive(true);
				}
			}
			animation.Play();
			StartCoroutine( TimeToFaceOut() );
		}
	}
	
	IEnumerator TimeToFaceOut()
	{
		yield return new WaitForSeconds( timeFaceOut );
		
		faceOut = true;
	}
}
