﻿using UnityEngine;
using System.Collections;

public class FallingCatNode : MonoBehaviour {
	[System.NonSerialized]
	public float currentSize 	= 1;
	[System.NonSerialized]
	public float minSize	 	= 0.7f;

	[System.NonSerialized]
	public int sizeDir			= 1;
	
	[System.NonSerialized]
	public float speed			= 100;

	[System.NonSerialized]
	private Transform transform;


	[System.NonSerialized]
	public HelperFallingCat helperFallingCat;

	[System.NonSerialized]
	public float limitPosY;

	public float limitVisibleY;


	private tk2dSprite sprite;


	public void Initialize()
	{
		sprite					= GetComponent<tk2dSprite>();
		transform 				= GetComponent<Transform>();
		transform.localScale 	= new Vector3( 1, 1, 1 ) * currentSize;

	}
	
	// Update is called once per frame
	void Update ()
	{
		string s = gameObject.name;
		speed = helperFallingCat.speed;
		if( (GameManager.Instance.SetupInitLevel.helpMode || GameManager.Instance.SetupInitLevel.tutorialMode) 
		   	&& DroppableBaseCat.IS_DRAGGING 
		   	&& DroppableBaseCat.typeCatOnMachine != DroppableBaseCat.TypeCat.LOVE
		   	&& DroppableBaseCat.typeCatOnMachine != DroppableBaseCat.TypeCat.BOMB )
		{
			renderer.enabled = true;
			
			limitPosY = helperFallingCat.limitPosY;
			limitVisibleY = helperFallingCat.limitVisibleY;
			
			if( helperFallingCat.hitSim )
			{
				sprite.SetSprite( "tutorial_hit" );
			}
			else
			{
				sprite.SetSprite( "tutorial_catFalling" );
			}
			
			
			if( transform.position.y < limitPosY )
			{
				sprite.color = Color.white;
				
				helperFallingCat.GoLastPosition( transform );
			}
			
			if( transform.position.y < limitVisibleY )
			{
				if( transform.position.y < limitVisibleY - 20 )
				{
					sprite.color = new Color( sprite.color.r, sprite.color.g, sprite.color.b, 0);
				}
				else
				{
					sprite.color = new Color( sprite.color.r, sprite.color.g, sprite.color.b, sprite.color.a - Time.deltaTime*4 );
				}
			}
			else
			{
				sprite.color = new Color( sprite.color.r, sprite.color.g, sprite.color.b, 1);
			}

			LoopMove();
			LoopSize();
		}
		else
		{
			renderer.enabled = false;
		}
	


	}

	void LoopSize()
	{
		currentSize = transform.localScale.x;
		
		if( 0 < sizeDir )
		{
			if( currentSize < 1 )
			{
				transform.localScale += Vector3.up*Time.deltaTime + Vector3.right*Time.deltaTime;
			}
			else
			{
				sizeDir = -1;
			}
		}
		else 
		{
			if( minSize < currentSize )
			{
				transform.localScale -= Vector3.up*Time.deltaTime + Vector3.right*Time.deltaTime;
			}
			else
			{
				sizeDir = 1;
			}
		}
	}

	void LoopMove()
	{
		transform.position -= Vector3.up * speed * Time.deltaTime;
	}
}
