﻿	using UnityEngine;
using System.Collections;

public class HelperFallingCat : MonoBehaviour {

	public GameObject[] nodes;

	public float offsetY = 60;

	public Vector3 initialPos;
	public float speed 	= 1;
	private float initialSpeed;
	private Transform transform;

	[System.NonSerialized]
	public float limitPosY = 0;

	public float limitVisibleY = 30;
	
	

	public Transform lastNode;

	public bool hitSim = false;


	// Use this for initialization
	void Start ()
	{
		initialSpeed = speed;

		transform = GetComponent<Transform>();
		initialPos = transform.position;

		lastNode = nodes[nodes.Length-1].transform;

		for (int i = 0; i < nodes.Length; i++)
		{
			nodes[i].transform.localPosition = Vector3.up * i * offsetY;

			FallingCatNode fallingCatNode = nodes[i].GetComponent<FallingCatNode>();

			fallingCatNode.helperFallingCat = this;
			fallingCatNode.speed 			= speed;
			fallingCatNode.limitPosY 		= limitPosY;
			fallingCatNode.limitVisibleY 	= limitVisibleY;

			if( i % 2 == 0 )
			{
				fallingCatNode.currentSize = fallingCatNode.minSize;
				fallingCatNode.Initialize();
			}
			else
			{
				fallingCatNode.Initialize();
			}
		}
	}

	void Update()
	{
		Vector3  positionScreen = GUICamera.instanceCamera.camera.WorldToScreenPoint( DroppableBaseCat.currentPosition );

		Vector3 positionWorld  =  Camera.main.ScreenToWorldPoint(positionScreen);
		transform.position = new Vector3( positionWorld.x, transform.position.y, -20 );
		limitVisibleY = positionWorld.y;
	
		//Solo detecta sims si el gato que va a caer en la maquina puede infectar. El love cat y el bomb cat no pueden infectar.
		if( 	DroppableBaseCat.typeCatOnMachine != DroppableBaseCat.TypeCat.LOVE
		   && 	DroppableBaseCat.typeCatOnMachine != DroppableBaseCat.TypeCat.BOMB )
		{
			DetectCollision();
		}
	}

	void DetectCollision()
	{
		hitSim 			= false;
		speed 			= initialSpeed;
	
		RaycastHit hit;
		
		if( GameManager.Instance.SetupInitLevel.VariousHeights )
		{
			if( Physics.Raycast( transform.position + Vector3.up * 5000, Vector3.down, out hit, 10000 ) 
			   && hit.transform.tag == "Crack"
			   && hit.transform.GetComponent<Crack>().IsOpen
			   && hit.transform.GetComponent<Crack>().TypeCrack != Crack.TCrack.EXIT_CRACK
			   )
			{

				if( Physics.Raycast( transform.position + Vector3.up * 5000, Vector3.down, out hit, 10000, 1 << LayerMask.NameToLayer("bodyCollider") )
				   && !hit.transform.parent.GetComponent<SimController>().Stats.IsInfecting
				   && !hit.transform.parent.GetComponent<SimController>().Stats.Infected )
				{
					limitVisibleY 	= hit.transform.position.y + 125;
					hitSim 			= true;
					speed 			= initialSpeed * 1.75f;
				}
				else
				{
					limitVisibleY 	= limitPosY;
				}
			}
			else
			{
				limitVisibleY 	= 360;
			}
		}
		else
		{
			if( Physics.Raycast( transform.position + Vector3.up * 5000, Vector3.down, out hit, 10000, 1 << LayerMask.NameToLayer("bodyCollider") )
			   && !hit.transform.parent.GetComponent<SimController>().Stats.IsInfecting
			   && !hit.transform.parent.GetComponent<SimController>().Stats.Infected )
			{
					limitVisibleY 	= hit.transform.position.y + 125;
					hitSim 			= true;
					speed 			= initialSpeed * 1.75f;
			}
			else
			{
				hitSim 			= false;
				speed 			= initialSpeed;
			}
		}
	}

	public void GoLastPosition(Transform node)
	{
		node.position = lastNode.position + Vector3.up*offsetY;
		lastNode = node;
	}

	void OnDrawGizmos()
	{
		Gizmos.DrawLine( GetComponent<Transform>().position+Vector3.up*5000, GetComponent<Transform>().position+Vector3.down*1000 );
	}
}
