﻿using UnityEngine;
using System.Collections;

public class TutorialHand : MonoBehaviour {


	private Transform target;

	private Vector3 targetPosition;

	public float speed = 2;

	public TutorialManager tutorialManager;

	//private Transform transform;

	private bool handActive = false;

	private float initialDistance;

	private Vector3 initialPosition;

	public tk2dSprite handSprite;
	public MeshRenderer rendererHand;

	public float speedFaceOut = 1.5f;

	[System.NonSerialized]
	public DroppableBaseCat currentDroppableCat;

	private bool firstTime = true;
	// Use this for initialization
	void Start ()
	{
		//transform 			= GetComponent<Transform>();
		initialPosition 	= transform.position;

		rendererHand = handSprite.GetComponent<MeshRenderer>();

	}

	// Update is called once per frame
	void Update ()
	{
		if( firstTime )
		{
			firstTime 			= false;
			transform.position	= CatMachineControllerCampaign.Instance.dragPoint.position;
			initialPosition 	= transform.position;
		}

		if( Time.timeScale == 0 || GameManager.Instance.GameStats.EndLevel )
		{
			rendererHand.enabled = false;
		}
		else
		{
			rendererHand.enabled = true;
		}
			
		if( handActive )
		{
			float currentDistance = Vector2.Distance(new Vector2( transform.position.x, transform.position.y ), new Vector2( targetPosition.x, targetPosition.y ) );
			
			if( 10 < currentDistance  )
			{
				transform.position = Vector3.Lerp( transform.position, targetPosition, Time.deltaTime*speed* (initialDistance/currentDistance) );
			}
			else
			{

				handSprite.color = new Color( handSprite.color.r, handSprite.color.g, handSprite.color.b, handSprite.color.a - Time.deltaTime*speedFaceOut );
				
				if( handSprite.color.a <= 0 )
				{
					Reset();
				}
			}
		}

	}

	private void Reset()
	{
		tutorialManager.NextState();

		handActive 			= false;
		transform.position 	= initialPosition;

		currentDroppableCat.Reset();
		
		gameObject.SetActive(false);

		

	}

	public void ActiveHand( Transform target )
	{
		this.target 			= target;

		rendererHand.enabled = true;

		//transform.position 	= CatMachineControllerCampaign.Instance.dragPoint.position;
		//transform.position 	= new Vector3(1,1,1);
		//GetComponent<Transform>().position 	= CatMachineControllerCampaign.Instance.dragPoint.position;
		
		StartCoroutine( TimerActive() );

		handSprite.color 	= new Color(1,1,1,1);
		handSprite.animation.Play();

		

		Vector3 positionScreen 	= Camera.main.WorldToScreenPoint( target.position );
		targetPosition 			= GUICamera.instanceCamera.ScreenToWorldPoint( positionScreen );

		initialDistance			= Vector2.Distance(new Vector2( transform.position.x, transform.position.y ), new Vector2( targetPosition.x, targetPosition.y ) );

	}

	IEnumerator TimerActive()
	{
		yield return new WaitForSeconds(0.8f);
		handActive = true;
		currentDroppableCat.OnDown();
		
	}

}
