﻿using UnityEngine;
using System.Collections;

public class TutorialPickCatArrow : MonoBehaviour {

	public float speedFaceOut 	= 2;
	public float lifeTime 		= 4;

	private bool faceOut = false;

	private tk2dSprite borderArrowSprite;
	private tk2dSprite arrowSprite;

	// Use this for initialization
	void Start ()
	{
		

		borderArrowSprite 	= transform.GetChild(0).GetComponent<tk2dSprite>();
		arrowSprite 		= borderArrowSprite.transform.GetChild(0).GetComponent<tk2dSprite>();

		gameObject.SetActive( false );
	}
	
	void Update()
	{
		
		if( !GameManager.Instance.SetupInitLevel.tutorialMode )
		{
			gameObject.SetActive(false);
		}

		if( faceOut )
		{
			borderArrowSprite.color = new Color( borderArrowSprite.color.r, borderArrowSprite.color.g, borderArrowSprite.color.b, borderArrowSprite.color.a - Time.deltaTime*speedFaceOut );
			arrowSprite.color 		= new Color( arrowSprite.color.r, arrowSprite.color.g, arrowSprite.color.b, arrowSprite.color.a - Time.deltaTime*speedFaceOut );
			
			if( borderArrowSprite.color.a <= 0 )
			{
				gameObject.SetActive(false);
			}
		}
	}

	public void ActiveArrow()
	{
		transform.position 	= CatMachineControllerCampaign.Instance.dragPoint.position;

		borderArrowSprite.color = new Color( borderArrowSprite.color.r, borderArrowSprite.color.g, borderArrowSprite.color.b, 1 );
		arrowSprite.color 		= new Color( arrowSprite.color.r, arrowSprite.color.g, arrowSprite.color.b, 1 );

		borderArrowSprite.GetComponent<MeshRenderer>().enabled 	= true;
		arrowSprite.GetComponent<MeshRenderer>().enabled 		= true;

		StartCoroutine( TimerFirstAnimation() );
			
		StartCoroutine( LifeTimer() );

	}

	IEnumerator LifeTimer()
	{
		yield return new WaitForSeconds( lifeTime );
		faceOut = true;
	}

	IEnumerator TimerFirstAnimation()
	{
		yield return new WaitForSeconds( 0.33f );
		borderArrowSprite.animation.Play( "tutPickCatArrow" );
	}
}
