﻿using UnityEngine;
using System.Collections;
using System.Collections.Generic;

public abstract class CatStates : FSMState
{
	
	protected CatController catController;
	protected LoveCatController loveCatController;
	protected DuplicatorCatController duplicatorCatController;
	protected DuplicatedCatController duplicatedCatController;
	protected BombCatController bombCatController;
	protected SkeletonAnimation sklAnim;
	protected CharacterController cc;
	
	protected string currentAnimation;
	
	
	/// <summary>
	/// Type of direction
	/// </summary>
	/*protected DirectionType tDirection = DirectionType.LEFT;*/
	
	public CatStates(GameObject entity, int id): base(entity, id)
	{
		catController 	= entity.GetComponent<CatController>();
		loveCatController = entity.GetComponent<LoveCatController>();
		duplicatorCatController = entity.GetComponent<DuplicatorCatController>();
		duplicatedCatController = entity.GetComponent<DuplicatedCatController>();
		bombCatController		= entity.GetComponent<BombCatController>();
		sklAnim 		= entity.GetComponent<SkeletonAnimation>();
		cc				= entity.GetComponent<CharacterController>();
		
		//setDirection();
		//setZSim();
		
	}
	public override void UpdateState()
	{
		
		
	}
	/*
	public void setDirection()
	{
		if (this.simController.Direction == SimController.DirectionType.RIGHT)
		{			
			this.charController.transform.rotation = new Quaternion(0.0f,180.0f,0.0f,0.0f);
		}
		if (this.simController.Direction == SimController.DirectionType.LEFT)
		{
			
			this.charController.transform.rotation = new Quaternion(0.0f,0.0f,0.0f,0.0f);
		}
		
	}
	private void setZSim()
	{
		float auxDistance = GameManager.Instance.FloorUpperLimit - this.charController.transform.position.y;
		float auxZ = GameManager.Instance.FarZSim - auxDistance;
		auxZ = Mathf.Clamp(auxZ,GameManager.Instance.FarZSim - 200, GameManager.Instance.FarZSim);
		
		float yPosition = Mathf.Clamp(this.charController.transform.position.y, 
			GameManager.Instance.FloorBottomLimit, 
			GameManager.Instance.FloorUpperLimit);
		this.charController.transform.position = new Vector3(this.charController.transform.position.x,
			yPosition,
			auxZ);
		
	}*/
	
	public List<SimController> DetectCleanSims()
	{
		List<SimController> cleanSims = new List<SimController>();
		
		SimController simControllerAux;
		for (int i = 0; i < GameManager.Instance.ListSims.Count; i++)
		{
			simControllerAux = GameManager.Instance.ListSims[i].GetComponent<SimController>();
			if( !simControllerAux.Stats.IsInfecting 
			   && !simControllerAux.Stats.Infected 
			   && GameManager.Instance.ListSims[i].GetComponent<CatAttacher>().cat == null
			   && simControllerAux.Stats.Number_Floor == catController.floor
			   && simControllerAux.Stats.CurrentState != SimController.State.SIM_FALL )
			{
				cleanSims.Add( GameManager.Instance.ListSims[i] );
			}
		}
		
		return cleanSims;
	}
	
	//distanceAttraction
	
	public List<SimController> DetectCleanSims( int dir )
	{
		List<SimController> cleanSims = new List<SimController>();
		
		SimController simControllerAux;
		for (int i = 0; i < GameManager.Instance.ListSims.Count; i++)
		{
			//A veces da errores de nulo. No estoy seguro pero creque q es cuadno disparan a un zombie y este desaparece.
			if( GameManager.Instance.ListSims[i] != null )
			{
				if( dir < 0 && GameManager.Instance.ListSims[i].transform.position.x < entity.transform.position.x
				   || 
				   0 < dir && entity.transform.position.x < GameManager.Instance.ListSims[i].transform.position.x
				   )
				{
					simControllerAux = GameManager.Instance.ListSims[i].GetComponent<SimController>();
					if( !simControllerAux.Stats.IsInfecting 
					   && !simControllerAux.Stats.Infected 
					   && GameManager.Instance.ListSims[i].GetComponent<CatAttacher>().cat == null
					   && simControllerAux.Stats.Number_Floor == catController.floor
					   && simControllerAux.Stats.CurrentState != SimController.State.SIM_FALL )
					{
						cleanSims.Add( GameManager.Instance.ListSims[i] );
					}	
				}
			}
		}
		
		return cleanSims;
	}
	/*
	
	public List<SimController> DetectSims()
	{
		//float auxLimit = GameManager.Instance.GetPositionCell(0,GameManager.Cell.NumberColumns-1).x;
		//this.targetPoint = new Vector3(auxLimit,this.charController.transform.position.y,0.0f);
		GameManager.Cell cell;
		if( duplicatedCatController == null )
		{
			cell = GameManager.Instance.GetCellByPos(entity.transform.position.x, entity.transform.position.y);
		}
		//Si es un gato duplicante tiene que comprobar si hay algun sims nada mas nacer en la cabeza de un sims. Asi que hay que aplicar un offset
		//para que busque como si estuviera en los pies del sims que ha infectado el duplicador.
		else
		{
			cell = GameManager.Instance.GetCellByPos(entity.transform.position.x, entity.transform.position.y-95);
		}
		int row 			= cell.Row;
		int column 			= cell.Column;
		
		List<SimController> listSims = new List<SimController>();
		listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row, column ));

		if( row == 0 )
		{
			listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row + 1, column ));
			
			if( 0 < column )
			{
				listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row + 1, column - 1));
			}
			if( column < GameManager.Cell.NumberColumns )
			{
				listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row + 1, column + 1));
			}
		}
		else
		{
			listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row - 1, column ));
			
			if( 0 < column )
			{
				listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row - 1, column - 1 ));
			}
			if( column < GameManager.Cell.NumberColumns )
			{
				listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row - 1, column + 1));
			}
		}
		
		if( 0 < column )
		{
			listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row, column - 1));
		}
		if( column < GameManager.Cell.NumberColumns )
		{
			listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row , column + 1));
		}

		return listSims;
	}
	
	public List<SimController>DetectSims(int deep)
	{
		//float auxLimit = GameManager.Instance.GetPositionCell(0,GameManager.Cell.NumberColumns-1).x;
		//this.targetPoint = new Vector3(auxLimit,this.charController.transform.position.y,0.0f);
		
		GameManager.Cell cell = GameManager.Instance.GetCellByPos(entity.transform.position.x, entity.transform.position.y);
		int row 			= cell.Row;
		int column 			= cell.Column;
		int dirRow			= 1;
		
		if ( 0 < row )
		{
			dirRow = -1;
		}
		
		List<SimController> listSims = new List<SimController>();
		listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row, column ));
		
		listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row + dirRow, column ));	
		
		for (int currentDeep = 1; currentDeep <= deep; currentDeep++)
		{
			if( 0 <= column - currentDeep )
			{
				listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row + dirRow, column - currentDeep ));
				listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row, column - currentDeep));
			}
			if( column + currentDeep <= GameManager.Cell.NumberColumns )
			{
				listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row + dirRow, column + currentDeep ));
				listSims = SumListSimsAux( listSims, GameManager.Instance.GetSimListCell( row , column + currentDeep));
			}
		}
		return listSims;
	}*/
	
	private List<SimController> SumListSimsAux( List<SimController> listSims, List<SimController> listSimsAux )
	{
		if( listSimsAux != null )
		{
			for (int i = 0; i < listSimsAux.Count; i++)
			{
				if (( !listSimsAux[i].Stats.Infected ) && (!listSimsAux[i].Stats.IsInfecting))
				{
					listSims.Add( listSimsAux[i] );
				}
			}
		}
		return listSims;
	}
	
	public void UpdateRotation()
	{
		if( catController.dir < 0 )
		{
			entity.transform.rotation = Quaternion.Euler( Vector3.zero );
		}
		else
		{
			entity.transform.rotation = Quaternion.Euler( Vector3.up*180 );
		}
	}
	
	public void SetAnimation(CatController.Animations anim)
	{
		this.sklAnim.animationName = anim.ToString();
	}
	
	protected void LookForSim()
	{
		List<SimController> listSims;
		if( duplicatedCatController != null )
		{
			listSims = DetectCleanSims( catController.dir );
		}
		else
		{
			listSims = DetectCleanSims();
		}
		
		if( 0 < listSims.Count )
		{
			SimController sim;
			float distanceMin = catController.GetDistance2D( entity.transform.position, listSims[0].transform.position );
			sim = listSims[0];
			for( int i = 0; i<listSims.Count; i++ )
			{
				if( catController.GetDistance2D(entity.transform.position, listSims[i].transform.position) < distanceMin )
				{
					distanceMin = catController.GetDistance2D(entity.transform.position, listSims[i].transform.position);
					sim = listSims[i];
				}
			}
			
			if( distanceMin < catController.distanceAttack  && sim.GetComponent<CatAttacher>().cat == null )
			{
				/*
				if( sim.GetComponent<SimController>().InfectedSimByCat() )
				{
					sim.GetComponent<CatAttacher>().AttachCat( entity );
					catController.InfectSim();
				}*/
				catController.targetSim = sim.gameObject;
				sim.Stats.IsInfecting = true;
			}
		}
	}
	//distanceAttraction
	protected void AttractSim(float distanceAttraction)
	{
		
		List<SimController> listSims = DetectCleanSims();
		
		if( 0 < listSims.Count )
		{
			if( 0 < listSims.Count )
			{
				for(int i = 0;i<listSims.Count;i++)
				{
					if( catController.GetDistance2D(entity.transform.position + Vector3.up*cc.radius, listSims[i].transform.position) < distanceAttraction )
					{
						Vector2 position2D = new Vector2(entity.transform.position.x, entity.transform.position.y);
						
						//listSims[i].SetLoveCat( position2D, deep );
						listSims[i].SetLoveCat( position2D, loveCatController.distanceAttraction );
					}
				}
				
			}
			/*SimController sim;
			float distanceMin = catController.GetDistance2D( entity.transform.position, listSims[0].transform.position );
			sim = listSims[0];
			for( int i = 0; i<listSims.Count; i++ )
			{
				if( catController.GetDistance2D(entity.transform.position, listSims[i].transform.position) < distanceMin )
				{
					distanceMin = catController.GetDistance2D(entity.transform.position, listSims[i].transform.position);
					sim = listSims[i];
				}
			}
			
			if( distanceMin < catController.distanceAttack  && sim.GetComponent<CatAttacher>().cat == null )
			{
				
				catController.targetSim = sim.gameObject;
				sim.Stats.IsInfecting = true;
			}*/
		}
	}



	protected void StunSims(float distanceStun)
	{
		
		List<SimController> listSims = DetectCleanSims();
		
		if( 0 < listSims.Count )
		{
			if( 0 < listSims.Count )
			{
				for(int i = 0;i<listSims.Count;i++)
				{
					if( catController.GetDistance2D(entity.transform.position + Vector3.up*cc.radius, listSims[i].transform.position) < distanceStun )
					{
						listSims[i].Stunned();
					}
				}
				
			}
		}
	}

	protected void DestroyCats(float distanceExplode)
	{
		
		List<Transform> listCats = GameManager.Instance.SettingCats.ListCatsFloor;
		
		if( 0 < listCats.Count )
		{
			if( 0 < listCats.Count )
			{
				for(int i = 0;i<listCats.Count;i++)
				{
					if( catController.GetDistance2D(entity.transform.position + Vector3.up*cc.radius, listCats[i].transform.position) < distanceExplode )
					{
						listCats[i].GetComponent<CatController>().DestroyCat();
						listCats.RemoveAt(i);

						if(0 < i)
						{
							i--;
						}
						
					}
				}
				
			}
		}
	}

}

public class Idle_CatState : CatStates
{
	
	public Idle_CatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		
		/*	int auxRandDir = Random.Range(0,10);
		if (auxRandDir < 6)
		{
			this.simController.Direction = SimController.DirectionType.LEFT;
		}else
		{
			this.simController.Direction = SimController.DirectionType.RIGHT;
		}
		
		this.setDirection();
		this.SetAnimation("idle");
		this.simController.Idle = true;
		*/
		
		SetAnimation( CatController.Animations.idle );
        //catController.StartCoroutine(TimerMeow());
		
	}
	
	public override void UpdateState()
	{
		
		if( loveCatController == null && bombCatController == null )
		{
			LookForSim();
		}
		
		UpdateRotation();
	}
	
	public override void Exit()
	{
		//Si instantZombie es igual a true, entonces infectara al instante
		if( catController.instantZombie )
		{
			catController.InfectSim();
		}
	}
    //SIGUIENTE VERSION
    /*
    IEnumerator TimerMeow()
    {
        GameManager.Instance.Sound_Manager.PlaySoundEffect(catController.meowCat);

        yield return new WaitForSeconds(5);
        catController.StartCoroutine(TimerMeow());
    }*/
}

public class Fall_CatState : CatStates
{
	float distanceAB;
	
	public Fall_CatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		SetAnimation( CatController.Animations.fall01 );
		catController.shadow.transform.localScale = new Vector3(0,0,0);
		distanceAB = entity.transform.position.y - catController.targetPosition.y;
		
		//Se restan los gatos del gameManager
		GameManager.Instance.SettingCats.TakeCat();
		//-325
	}
	
	public override void UpdateState()
	{
		Vector3 origin = entity.transform.position + cc.center;
		RaycastHit hit;
		if( Physics.Raycast(origin, Vector3.down, out hit, cc.radius + cc.radius/2 ) )
		{
			if( hit.transform.gameObject.layer == LayerMask.NameToLayer("bodyCollider") )
			{
				SimController simController = hit.transform.parent.GetComponent<SimController>();

				if(!simController.Stats.IsInfecting && !simController.Stats.Infected )
				{
					//Si tiene escudo no le infectara
					if( simController.Stats.HasShield )
					{
						simController.RemoveShield();
						//provisional1!!
						//GameObject.Destroy( entity );
						catController.DestroyCat();
					}
					else
					{
						if( simController.InfectedSimByCat( catController.instantZombie ) )
						{
							hit.transform.parent.GetComponent<CatAttacher>().AttachCat( entity );
							catController.InfectSim();
							catController.targetSim = hit.transform.parent.gameObject;
							simController.Stats.IsInfecting = true;

							GameManager.Instance.SettingCats.AddCat( entity.transform );
						}
					}
				}
			}
			else if( 0 < catController.floor && hit.transform.gameObject.tag == "Crack" && hit.transform.GetComponent<Crack>().IsOpen )
			{
				
				//catController.targetPosition += Vector3.down*325;
				catController.targetPosition += Vector3.down*GameManager.Instance.SimSetupSettings.FloorDistance;

				catController.floor			= 0;
				
				entity.transform.position = new Vector3(entity.transform.position.x,entity.transform.position.y,hit.transform.position.z);
				catController.StartCoroutine( TimerAdjustZHole() );
			}
		}
		UpdateRotation();
		cc.Move( Vector3.down * catController.fallSpeed * Time.deltaTime );
		

		if( entity.transform.position.y - catController.targetPosition.y < distanceAB/5 )
		{
			catController.shadow.transform.position = new Vector3(catController.targetPosition.x, catController.targetPosition.y+10, catController.shadow.transform.position.z);
			ControlShadowScale();
		}
	}
	
	public override void Exit()
	{
	}
	
	IEnumerator TimerAdjustZHole()
	{
		entity.GetComponent<ConfigZ>().enabled = false;
		yield return new WaitForSeconds(0.4f);
		entity.GetComponent<ConfigZ>().enabled = true;
	}
	
	void ControlShadowScale()
	{
		//float scale = 1-(entity.transform.position.y - catController.targetPosition.y)/distanceAB;
		float scale = 1-(entity.transform.position.y - catController.targetPosition.y)/distanceAB*4;
		catController.shadow.transform.localScale = new Vector3(scale, scale, scale);
	}
}

public class Zombie_CatState : CatStates
{
	private bool firstTime = true;
	private SimController simController;

	public Zombie_CatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		
		/*	int auxRandDir = Random.Range(0,10);
		if (auxRandDir < 6)
		{
			this.simController.Direction = SimController.DirectionType.LEFT;
		}else
		{
			this.simController.Direction = SimController.DirectionType.RIGHT;
		}
		
		this.setDirection();
		this.setAnimation("idle");
		this.simController.Idle = true;
		*/
		
		firstTime = true;
		SetAnimation( CatController.Animations.zombie );
		
		catController.shadow.SetActive(false);
		//Desactivamos el componente de ConfigZ para que se atache correctamente a la cabeza del sim
		entity.GetComponent<ConfigZ>().enabled = false;
		
		/*
		sklAnim.animationName = "zombie";
		Spine.Animation animation = sklAnim.skeleton.Data.FindAnimation("zombie");
		sklAnim.state.SetAnimation(animation, false);*/

		simController = catController.targetSim.GetComponent<SimController>();
	}
	
	public override void UpdateState()
	{
		if( firstTime && simController != null  )
		{
			if( simController.Stats.Infected )
			{
				GameManager.Instance.SettingCats.RemoveCatFloor( entity.transform );
				firstTime = false;
			}
			else if( simController.Stats.CurrentState == SimController.State.SIM_FALL )
			{
				catController.DestroyCat();
			}


		}
	}
	
	public override void Exit()
	{
	}
}

public class Land_CatState : CatStates
{
	private float timeAnimationPart1 = 1.17f;
	//private float timeAnimationPart2 = 0.3f;
	private float startTimeAnimationPart1;
	//private float startTimeAnimationPart2;
	
	public Land_CatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		SetAnimation( CatController.Animations.land01_part1 );
		startTimeAnimationPart1 = Time.time;
		
		//catController.maxX = entity.transform.position.x + cc.center + Vector3.right*catController.distancePatrol;
		//catController.minX = entity.transform.position.x + cc.center - Vector3.right*catController.distancePatrol;
		
		catController.helperCircle.SetActive( true );
		
		GameManager.Instance.SettingCats.AddCat( entity.transform );
	}
	
	public override void UpdateState()
	{
		if( 0 < startTimeAnimationPart1 && startTimeAnimationPart1 + timeAnimationPart1 < Time.time )
		{
			startTimeAnimationPart1 = -1;
			//startTimeAnimationPart2 = Time.time;
			SetAnimation( CatController.Animations.land01_part2 );
		}
		if( loveCatController != null )
		{
			AttractSim( loveCatController.distanceAttraction );
		}
		/*
		if( startTimeAnimationPart1 < 0 && startTimeAnimationPart2 + timeAnimationPart2 < Time.time )
		{
			catController.fsm.ChangeState( (int)CatController.State.IDLE );
		}*/
	}
	
	public override void Exit()
	{
	}
}

public class Jump_CatState : CatStates
{
	
	Vector3 target1;
	float targetY;
	
	bool phase1  = true;
	
	
	public Jump_CatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		SetAnimation( CatController.Animations.jump );
		if( entity.transform.position.x < catController.targetSim.transform.position.x )
		{
			catController.dir = 1;
		}
		else
		{
			catController.dir = -1;
		}
		catController.shadow.SetActive(false);
		
		target1 	= catController.targetSim.transform.position + Vector3.up*(catController.targetSim.GetComponent<CharacterController>().height+25);
		target1 	-= Vector3.right*(catController.targetSim.transform.position.x - entity.transform.position.x)/2;
		
		catController.helperCircle.SetActive( false );
	}
	
	public override void UpdateState()
	{
		Vector3 dir;
		if( phase1 )
		{
			dir = target1 - entity.transform.position;
			//dir = catController.targetSim.transform.position + Vector3.up*catController.targetSim.GetComponent<CharacterController>().height - entity.transform.position;
			dir = Vector3.Normalize(dir);
			
			cc.Move( dir*catController.jumpSpeed*Time.deltaTime*2f );

			float distance = catController.GetDistance2D(target1, entity.transform.position);

			if( distance < 10  )
			{
				phase1 = false;
			}
		}
		else
		{
			dir = catController.targetSim.transform.position + Vector3.up*catController.targetSim.GetComponent<CharacterController>().height - entity.transform.position;
			dir = Vector3.Normalize(dir);
			
			cc.Move( dir*catController.jumpSpeed*Time.deltaTime*2f );
			
			if( catController.GetDistance2D(entity.transform.position, catController.targetSim.transform.position + Vector3.up*catController.targetSim.GetComponent<CharacterController>().height) < 20 )
			{
				/*
				if( catController.targetSim.GetComponent<SimController>().Stats.HasShield )
				{
					catController.targetSim.GetComponent<SimController>().RemoveShield();
					catController.targetSim.GetComponent<SimController>().Stats.IsInfecting = false;
					catController.targetSim = null;
					
					//provisional1!!
					GameObject.Destroy( entity );
				}
				else if( catController.targetSim.GetComponent<SimController>().InfectedSimByCat() )
				{
					catController.targetSim.GetComponent<CatAttacher>().AttachCat( entity );
					catController.InfectSim();
				}*/
				catController.InfectSim();
				
			}
		}
		
		
		
		/*
		 Vector3 dir = catController.targetSim.transform.position + Vector3.up*catController.targetSim.GetComponent<CharacterController>().height - entity.transform.position;
			dir = Vector3.Normalize(dir);
			
			cc.Move( dir*catController.jumpSpeed*Time.deltaTime );
			float d = GetDistance2D(entity.transform.position, catController.targetSim.transform.position);
			if( GetDistance2D(entity.transform.position, catController.targetSim.transform.position + Vector3.up*catController.targetSim.GetComponent<CharacterController>().height) < 20 )
			{
				if( catController.targetSim.GetComponent<SimController>().InfectedSimByCat() )
				{
					catController.targetSim.GetComponent<CatAttacher>().AttachCat( entity );
					catController.InfectSim();
				}
			}
		 */
		
		UpdateRotation();
	}
	
	public override void Exit()
	{
	}
}

public class Patrol_CatState : CatStates
{
	Vector3 destinationDir;
	public Patrol_CatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		SetAnimation( CatController.Animations.walk );
		
		//catController.distancePatrol = catController.distancePatrol;
		
		catController.dir *= -1;
		
		if( catController.dir < 0 )
		{
			//destination = entity.transform.position + Random.Range( catController.minX, catController.maxX );
			catController.destinationPatrol = entity.transform.position - Vector3.right*catController.distancePatrol;
		}
		else
		{
			catController.destinationPatrol = entity.transform.position + Vector3.right*catController.distancePatrol;
		}
	}
	
	public override void UpdateState()
	{
		if( loveCatController == null )
		{
			LookForSim();
		}
		
		destinationDir = Vector3.Normalize( catController.destinationPatrol-entity.transform.position );
		
		cc.Move( destinationDir*catController.speed*Time.deltaTime );
		
		
		UpdateRotation();
	}
	
	public override void Exit()
	{
	}
}

public class SitIdle_CatState : CatStates
{
	public SitIdle_CatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		
		switch( Random.Range(0,3) )
		{
		case 0:
			SetAnimation( CatController.Animations.sitIdle );
			break;
		case 1:
			SetAnimation( CatController.Animations.sitIdle_lickBalls );
			break;
		case 2:
			SetAnimation( CatController.Animations.sitIdle_lickLeg );
			break;
		}	
		
	}
	
	public override void UpdateState()
	{
		if( loveCatController == null )
		{
			LookForSim();
		}
	}
	
	public override void Exit()
	{
	}
}



#region loveCat
public class Idle_LoveCatState : CatStates
{
	
	public Idle_LoveCatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		//Si esta desactivado signifca que es la primera vez qu entra en el idle, entonces se quedara en idle un timepo y despues entrara rareIdle y a partir de ahi se quedara
		//con la animacion de sleep;
		if( !loveCatController.sleepEffect.activeSelf )
		{
			SetAnimation( CatController.Animations.idle );
		}
		else
		{
			SetAnimation( CatController.Animations.sleep );

		}

       // catController.StartCoroutine(TimerPurr());

	}
	
	public override void UpdateState()
	{
		AttractSim( loveCatController.distanceAttraction );
		UpdateRotation();
	}
	
	public override void Exit()
	{
	}
    //PROXIMA VERSION?
    /*
    IEnumerator TimerPurr()
    {
        GameManager.Instance.Sound_Manager.PlaySoundEffect(loveCatController.purr);

        yield return new WaitForSeconds(10);
        catController.StartCoroutine(TimerPurr());
    }*/
}

public class Fall_LoveCatState : CatStates
{
	float distanceAB;
	
	public Fall_LoveCatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		SetAnimation( CatController.Animations.fall01 );
		catController.shadow.transform.localScale = new Vector3(0,0,0);
		distanceAB = entity.transform.position.y - catController.targetPosition.y;
		
		//Se restan los gatos del gameManager
		GameManager.Instance.SettingCats.TakeCat();

		
	}
	
	public override void UpdateState()
	{
		
		UpdateRotation();
		cc.Move( Vector3.down * catController.fallSpeed * Time.deltaTime );
		
		Vector3 origin = entity.transform.position + cc.center;
		RaycastHit hit;
		if( Physics.Raycast(origin, Vector3.down, out hit, cc.radius + cc.radius/4 ) )
		{
			if( 0 < catController.floor && hit.transform.gameObject.tag == "Crack" && hit.transform.GetComponent<Crack>().IsOpen )
			{
				catController.targetPosition += Vector3.down*350;
				catController.floor			= 0;
				
				entity.transform.position = new Vector3(entity.transform.position.x,entity.transform.position.y,hit.transform.position.z);
				catController.StartCoroutine( TimerAdjustZHole() );
			}
		}
		float d = entity.transform.position.y - catController.targetPosition.y;
		if( entity.transform.position.y - catController.targetPosition.y < distanceAB/5 )
		{
			catController.shadow.transform.position = new Vector3(catController.targetPosition.x, catController.targetPosition.y+10, catController.shadow.transform.position.z);
			ControlShadowScale();
		}

		
		
	}
	
	public override void Exit()
	{
	}
	
	IEnumerator TimerAdjustZHole()
	{
		entity.GetComponent<ConfigZ>().enabled = false;
		yield return new WaitForSeconds(0.4f);
		entity.GetComponent<ConfigZ>().enabled = true;
	}
	
	void ControlShadowScale()
	{
		float scale = 1-(entity.transform.position.y - catController.targetPosition.y)/distanceAB*4;
		catController.shadow.transform.localScale = new Vector3(scale, scale, scale);
	}
}

public class SitIdle_LoveCatState : CatStates
{
	public SitIdle_LoveCatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		loveCatController.sleepEffect.SetActive(true);
		SetAnimation( CatController.Animations.sleep );
		/*
		switch( Random.Range(0,3) )
		{
			case 0:
				SetAnimation( CatController.Animations.sitIdle );
				break;
			case 1:
				SetAnimation( CatController.Animations.sitIdle_lickBalls );
				break;
			case 2:
				SetAnimation( CatController.Animations.sitIdle_lickLeg );
				break;
		}*/
	}
	
	public override void UpdateState()
	{
		AttractSim( loveCatController.distanceAttraction );
	}
	
	public override void Exit()
	{
	}
}

#endregion
#region DuplicatorCat
public class Zombie_DuplicatorCatState : CatStates
{
	
	public Zombie_DuplicatorCatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		
		GameManager.Instance.SettingCats.RemoveCatFloor( entity.transform );
		
		SetAnimation( CatController.Animations.zombie );
		
		catController.shadow.SetActive(false);
		
		if( duplicatorCatController != null )
		{
			duplicatorCatController.SpawnCats();
		}
		entity.GetComponent<ConfigZ>().enabled = false;
		
		//Instanciar 2 gatos duplicados.
	}
	
	public override void UpdateState()
	{
		
		//UpdateRotation();
	}
	
	public override void Exit()
	{
	}
}
#endregion

#region DuplicatedCat
public class FirstJump_DuplicatedCatState : CatStates
{
	Vector3 targetJump;
	bool phase1 = true;
	float distanceAB;
	
	public FirstJump_DuplicatedCatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		//Hace la animacion de roll
		SetAnimation( CatController.Animations.walk );
		
		//modificar esto.
		//target1 	= catController.targetSim.transform.position + Vector3.up*(catController.targetSim.GetComponent<CharacterController>().height+25);
		targetJump 	= entity.transform.position + Vector3.right*catController.dir*catController.distanceAttack/2 + Vector3.up*25;
		catController.targetPosition 	= entity.transform.position + Vector3.right*catController.dir*catController.distanceAttack - Vector3.up*(80);
		
		distanceAB = entity.transform.position.y - catController.targetPosition.y;
		
		LookForSim();
		sklAnim.timeScale = 1.5f;

		GameManager.Instance.SettingCats.AddCat( entity.transform );
		
	}
	
	public override void UpdateState()
	{
		//MODIFICAR CON LO QUE CORRESPONDA
		
		Vector3 dir;
		if( phase1 )
		{
			dir = targetJump - entity.transform.position;
			//dir = catController.targetSim.transform.position + Vector3.up*catController.targetSim.GetComponent<CharacterController>().height - entity.transform.position;
			dir = Vector3.Normalize(dir);
			
			cc.Move( dir*catController.jumpSpeed*Time.deltaTime*2f );
			
			if( catController.GetDistance2D(targetJump, entity.transform.position) < 10  )
			{
				phase1 = false;
			}
		}
		else
		{
			dir = catController.targetPosition - entity.transform.position;
			dir = Vector3.Normalize(dir);
			
			cc.Move( dir*catController.jumpSpeed*Time.deltaTime );
			/*
			if( catController.GetDistance2D(entity.transform.position, catController.targetPosition) < 20 )
			{
				catController.fsm
			}*/
		}
		
		catController.shadow.transform.position = new Vector3(entity.transform.position.x, catController.targetPosition.y+10, catController.shadow.transform.position.z);
		ControlShadowScale();
		
		UpdateRotation();
	}
	public override void Exit(){}
	
	void ControlShadowScale()
	{
		float scale = 0.5f + (1-(entity.transform.position.y - catController.targetPosition.y)/distanceAB)/2;
		catController.shadow.transform.localScale = new Vector3(scale, scale, scale);
	}
}

public class Roll_DuplicatedCatState : CatStates
{
	
	public Roll_DuplicatedCatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		//Hace la animacion de roll
		SetAnimation( CatController.Animations.walk );
		catController.shadow.transform.localPosition = catController.shadow.transform.localPosition + Vector3.right*-10;
		catController.helperCircle.SetActive( true );
		
	}
	
	public override void UpdateState()
	{
		if( loveCatController == null )
		{
			LookForSim();
		}
		//modificar con lo que corresponda
		cc.Move( Vector3.right*catController.dir*catController.speed*Time.deltaTime );
		
		
		UpdateRotation();
		
	}
	
	public override void Exit(){
		sklAnim.timeScale = 1;
	}
	
	
}
#endregion

#region SpeedCat
public class Zombie_SpeedCatState : CatStates
{
	
	public Zombie_SpeedCatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		GameManager.Instance.SettingCats.RemoveCatFloor( entity.transform );
		
		SetAnimation( CatController.Animations.zombie );
		
		catController.shadow.SetActive(false);
		
		catController.targetSim.GetComponent<SimController>().SetFastCat();
		
		entity.GetComponent<ConfigZ>().enabled = false;
		//Instanciar 2 gatos duplicados.
	}
	
	public override void UpdateState()
	{
		
		//UpdateRotation();
	}
	
	public override void Exit()
	{
	}
}
#endregion

#region BombCat
public class Idle_BombCatState : CatStates
{
	
	public Idle_BombCatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		SetAnimation( CatController.Animations.idle );
	}
	
	public override void UpdateState()
	{
		UpdateRotation();
	}
	
	public override void Exit()
	{
	}
}

public class Explode_BombCatState : CatStates
{
	
	public Explode_BombCatState(GameObject entity, int id) : base(entity, id){}
	
	public override void Enter()
	{
		
		/*	int auxRandDir = Random.Range(0,10);
		if (auxRandDir < 6)
		{
			this.simController.Direction = SimController.DirectionType.LEFT;
		}else
		{
			this.simController.Direction = SimController.DirectionType.RIGHT;
		}
		
		this.setDirection();
		this.SetAnimation("idle");
		this.simController.Idle = true;
		*/
		bombCatController.startTime_DelayExplosion = Time.time;
		
		SetAnimation( CatController.Animations.bomb );
	}
	
	public override void UpdateState()
	{
		if( bombCatController.startTime_DelayExplosion + bombCatController.delayExplosion < Time.time )
		{
			bombCatController.Explode();

			StunSims( bombCatController.distanceExplosion );

			GameManager.Instance.SettingCats.ListCatsFloor.Remove(entity.transform);

			DestroyCats( bombCatController.distanceExplosion );

            
		}
		UpdateRotation();
	}
	
	public override void Exit()
	{
		
	}
}
#endregion