using UnityEngine;
using System.Collections;

public class CoinBrokeEffect : MonoBehaviour {

	private Vector3 currentSpeed;
	private float initialY;
	public float lifeTime = 0.25f;
	private float startTimeLife;
	
	public float speedAlpha = 1;
	public float speedSize = 0.25f;
	
	public float rotationSpeed = 10;
	
	private int dir = 0;
	
	private Vector3 positionCoinGUI;
	private tk2dSprite sprite;
	
	private int indexState = 0;
	
	// Use this for initialization
	void Start () {
		sprite = GetComponent<tk2dSprite>();
		
		int xRand 	= Random.Range(2,5)*15;
		dir  	= Random.Range(0,2);
		if(dir == 0)
		{
			dir = -1;
		}
		int yRand 	= Random.Range(1,4)*3;
		currentSpeed = new Vector3(dir*xRand,200+yRand,0);
		
		initialY = transform.position.y;
		initialY += Random.Range(-5,5)*10;
		
		//transform.localScale = new Vector3(0.5f,0.5f,1);
		
		positionCoinGUI = CoinGUI.instance.position;
		
		startTimeLife = Time.time;
		
		//StartCoroutine(TimerLife());
		
		//sprite.color		= new Color( sprite.color.r, sprite.color.g, sprite.color.b, 0.8f);
	}
	
	void Update()
	{
		//sprite.color		= new Color( sprite.color.r, sprite.color.g, sprite.color.b, sprite.color.a-Time.deltaTime*speedAlpha);
		float sizeDir = 1;
		if( lifeTime/2 + startTimeLife > Time.time )
		{
			sizeDir = -1;
		}
		//transform.localScale += sizeDir*(Vector3.up*Time.deltaTime*speedSize + Vector3.right*Time.deltaTime*speedSize);
		
		//transform.position 	+= currentSpeed * Time.deltaTime;
		//currentSpeed 		+= Vector3.down*20;
		transform.rotation = Quaternion.AngleAxis(transform.rotation.eulerAngles.z+dir*rotationSpeed,Vector3.forward);
		
		
		switch( indexState )
		{
			case 0:
				if( !(transform.position.y <= initialY && currentSpeed.y < 0) )
				{
					transform.position 	+= currentSpeed * Time.deltaTime;
					currentSpeed 		+= Vector3.down*10;
				
				}
				else
				{
					currentSpeed.y = 150;
					indexState++;
				}
				break;
			case 1:
				if( !(transform.position.y <= initialY && currentSpeed.y < 0) )
				{
					transform.position 	+= currentSpeed * Time.deltaTime;
					currentSpeed 		+= Vector3.down*10;
				
				
				}
				else
				{
					indexState++;
				}
				break;
			case 2:
				if( transform.localScale.x < 0.1f )
				{
					Destroy( gameObject );
				}
				transform.localScale -= new Vector3( 0.1f, 0.1f, 0.1f );
				break;
		}
	}
	/*
	IEnumerator TimerLife()
	{
		yield return new WaitForSeconds(lifeTime);
		Destroy(gameObject);
	}*/
}
