﻿using UnityEngine;
using System.Collections;

public class FX_DeadCatCloud : MonoBehaviour {

	[System.NonSerialized]
	public Vector2 dir = Vector2.zero;

	[System.NonSerialized]
	public float speed = 100;

	[System.NonSerialized]
	public float rotationSpeed = 2;
	

	
	[System.NonSerialized]
	private float timeLife = 0.2f;
	
	private bool startDying = false;
	
	private tk2dSprite sprite;

	private int dirRotation;

	// Use this for initialization
	void Start () {
		StartCoroutine( TimerLifeTime() );
		sprite = GetComponent<tk2dSprite>();
		speed = speed - Random.Range(0, speed/4);
		dirRotation = Random.Range(0,2);
		if( dirRotation < 1 )
		{
			dirRotation = -1;
		}
	}
	
	// Update is called once per frame
	void Update () {
		//Nos aseguremos de que en todo momento el renderer este en enable porque por alguna razon si
		//si en la animacion desactivo el renderer del script que instancia este gameObject, este ultimo se desactiva tambien. Sad panda.
		renderer.enabled = true;
		//transform.localScale = new Vector3(1,1,1);
		transform.localScale = new Vector3(1,1,1);
		//transform.localScale -= (Vector3.right + Vector3.up)*0.001f*Time.deltaTime;
		if( startDying )
		{
			speed -= speed*Time.deltaTime;
			sprite.color = new Color( sprite.color.r, sprite.color.g, sprite.color.b, sprite.color.a - Time.deltaTime );
			transform.position += (Vector3.right*dir.x +  Vector3.up*dir.y)*speed*Time.deltaTime;

			if( sprite.color.a <= 0 )
			{
				Destroy(gameObject);
			}
		}
		else
		{
			transform.position += (Vector3.right*dir.x +  Vector3.up*dir.y)*speed*Time.deltaTime;
		}

		transform.Rotate(0,0,dirRotation*rotationSpeed);
	}

	IEnumerator TimerLifeTime()
	{
		yield return new WaitForSeconds( timeLife );
		startDying = true;
	}
}
