using UnityEngine;
using System.Collections;

public class Feather : MonoBehaviour {
	
	[System.NonSerialized]
	public float speedX = 60;
	
	[System.NonSerialized]
	public float speedY = 75;
	
	[System.NonSerialized]
	public int dir = 0;
	
	[System.NonSerialized]
	public float timeLife = 1.5f;
	
	private bool startDying = false;
	
	private tk2dSprite sprite;
	
	private float destinationX;
	
	// Use this for initialization
	void Start () {
		StartCoroutine( TimerDie() );
		
		sprite = GetComponent<tk2dSprite>();
		
		speedX -= speedX/2/Random.Range(1,6);
		
		SetRandomDetinationX();
		
	}
	
	// Update is called once per frame
	void Update () {
		
		if( dir < 0 && transform.position.x < destinationX || 0 < dir && destinationX < transform.position.x )
		{
			SetRandomDetinationX();
		}
		
		transform.position += Vector3.right*dir*speedX*Time.deltaTime - Vector3.up*speedY*Time.deltaTime;
		
		if( startDying )
		{
			sprite.color = new Color( sprite.color.r, sprite.color.g, sprite.color.b, sprite.color.a - Time.deltaTime*4 );
			if( sprite.color.a <= 0 )
			{
				Destroy(gameObject);
			}
		}
	}
	
	void SetRandomDetinationX()
	{
		dir *= -1;
		destinationX = transform.position.x + dir*Random.Range(30, 40);
	}
	
	IEnumerator TimerDie()
	{
		yield return new WaitForSeconds( timeLife );
		startDying = true;
	}
}
