using UnityEngine;
using System.Collections;

public class ShinyCoinEffect : MonoBehaviour {

	private Vector3 currentSpeed;
	private float initialY;
	public float lifeTime = 0.25f;
	private float startTimeLife;
	
	public float speedAlpha = 1;
	public float speedSize = 0.25f;
	
	
	private Vector3 positionCoinGUI;
	private tk2dSprite sprite;
	
	
	
	// Use this for initialization
	void Start () {
		sprite = GetComponent<tk2dSprite>();
		
		int xRand 	= Random.Range(2,6)*100;
		int dir  	= Random.Range(0,2);
		if(dir == 0)
		{
			dir = -1;
		}
		int yRand 	= Random.Range(-4,5)*100;
		currentSpeed = new Vector3(dir*xRand,200+yRand,0);
		
		initialY = transform.position.y;
		initialY += Random.Range(-5,5)*5;
		
		//transform.localScale = new Vector3(0.5f,0.5f,1);
		
		positionCoinGUI = CoinGUI.instance.position;
		
		startTimeLife = Time.time;
		
		StartCoroutine(TimerLife());
		
		//sprite.color		= new Color( sprite.color.r, sprite.color.g, sprite.color.b, 0.8f);
	}
	
	void Update()
	{
		//sprite.color		= new Color( sprite.color.r, sprite.color.g, sprite.color.b, sprite.color.a-Time.deltaTime*speedAlpha);
		float sizeDir = 1;
		if( lifeTime/2 + startTimeLife > Time.time )
		{
			sizeDir = -1;
		}
		transform.localScale += sizeDir*(Vector3.up*Time.deltaTime*speedSize + Vector3.right*Time.deltaTime*speedSize);
		
		transform.position 	+= currentSpeed * Time.deltaTime;
		currentSpeed 		+= Vector3.down*20;
		
		//transform.Rotate( new Vector3(0,0,Time.deltaTime*1000) ); 
		
		//transform.rotation = Quaternion.Euler(transform.rotation.eulerAngles + Vector3.forward*4);
	}
	
	IEnumerator TimerLife()
	{
		yield return new WaitForSeconds(lifeTime);
		Destroy(gameObject);
	}
}
