﻿using UnityEngine;
using System.Collections;

public class FX_EffectSleep : MonoBehaviour {
	
	public Vector3 currentPosition;
	private float maxPositionY = 165;
	private Vector3 startPosition = new Vector3(314.08f,113.50f,0);
	
	
	private Vector3 velocity = Vector3.up;
	public float xAccel = 0.25f;
	
	private float scaleSpeed = 0.05f;
	
	private bool respawn;

	private tk2dSprite sprite;
	
	public float startDelay = 0;
	
	private bool canStart = true;
	
	void Start()
	{
		sprite = GetComponent<tk2dSprite>();
		if( 0 < startDelay )
		{
			canStart = false;
			StartCoroutine( TimerStartDelay() );
		}
	}
	
	// Update is called once per frame
	void Update () {
		if( canStart )
		{
			velocity += Vector3.right*Time.deltaTime*xAccel;
			transform.position += velocity;
			transform.localScale += (Vector3.up+Vector3.right)*scaleSpeed*Time.deltaTime;
			if(  maxPositionY < transform.localPosition.y )
			{
				
				FaceOut();
				
				if( !respawn )
				{
					respawn = true;
					StartCoroutine( TimerRespawn() );	
				}
			}
		}
	}
	
	void FaceOut()
	{
		sprite.color = new Color( sprite.color.r,sprite.color.g,sprite.color.b, sprite.color.a-2*Time.deltaTime );
	}
	
	IEnumerator TimerStartDelay()
	{
		sprite.color = new Color( sprite.color.r,sprite.color.g,sprite.color.b, 0 );
		yield return new WaitForSeconds( startDelay );
		sprite.color = new Color( sprite.color.r,sprite.color.g,sprite.color.b, 1 );
		canStart = true;
	}
	
	IEnumerator TimerRespawn()
	{
		yield return new WaitForSeconds( 0.75f );
		sprite.color = new Color( sprite.color.r,sprite.color.g,sprite.color.b, 1 );
		transform.localPosition = startPosition+Vector3.forward*transform.localPosition.z;
		transform.localScale = new Vector3(0.5f,0.5f,0.5f);
		velocity = Vector3.up;
		respawn = false;
	}
}
